////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once

class CSetupInfo
{
	char* 	m_sIP;
	int		m_nPort;
	int		m_nShowImages;
	int		m_nAutoUpdateIP;
	int		m_nTestPort;
	int		m_nStartOnStartUp;
	char* 	m_sName;
	int		m_nCheckForUpdatesOnStartUp;

	char* 	m_Common;
	char* 	m_Unit;
	char* 	m_Organization;
	char* 	m_Email;
	char* 	m_Country;
	char* 	m_State;
	int		m_nRegenrateOnStartUp;
	int		m_nLogLevel;
	char*	m_sIPServer;
	char*	m_sFinger;

public:
	CSetupInfo();
	
	CSetupInfo(const char* sIn);
	~CSetupInfo();

public:
	char*	GetIP();
	void	SetIP(const char* _sIP);

	int		GetShowImages();
	void	SetShowImages(int _nShowImages);

	int		GetPort();
	void	SetPort(int _nPort);

	int		GetAutoUpdateIP();
	void	SetAutoUpdateIP(int _nAutoUpdateIP);

	int		GetTestPort();
	void	SetTestPort(int _nTestPort);

	int		GetStartOnStartUp();
	void	SetStartOnStartUp(int _nStartOnStartUp);

	char*	GetName();
	void	SetName(const char* _sName);

	int		GetCheckForUpdatesOnStartUp();
	void	SetCheckForUpdatesOnStartUp(int _nCheckForUpdatesOnStartUp);

	bool	Store();
	void	Load();

	void	SetCommon(const char* _Common);
	void	SetUnit(const char* _Unit);
	void	SetOrganization(const char* _Organization);
	void	SetEmail(const char* _Email);
	void	SetCountry(const char* _Country);
	void	SetState(const char* _State);
	void	SetRegenrateOnStartUp(int _nRegenrateOnStartUp);

	char*	GetCommon();
	char*	GetUnit();
	char*	GetOrganization();
	char*	GetEmail();
	char*	GetCountry();
	char*	GetState();
	int		GetRegenrateOnStartUp();

	int		GetLogLevel();
	void	SetLogLevel(int _nLogLevel);

	char*	GetIPServer();
	void	SetIPServer(const char* pIPServer);

	char*	GetFinger();
	void	SetFinger(const char* pFinger);

protected:
	void	Init();
	void	Out(char*& sOut);

	void	Parse(const char* sIn);
};

extern 	CSetupInfo g_info;

