////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once
#include <vector>
#include "parsedUrl.h"

class CCookie
{
protected:
	char* 	m_pCookieDomain; 
	char* 	m_pCookieName; 
	char* 	m_pCookieVal; 
	char* 	m_pCookiePath; 
	char* 	m_pCookieExpires; 

public:
	CCookie();
	~CCookie();
	
	void	Init();
	void	Reset();
	void	Setup(char* sRawCookieStr, const CParsedUrl& parURL);
	
public:
	void	SetCookieDomain(const char* domain);
	char*	GetCookieDomain(void);
	
	void	SetCookieName(const char* name);
	char*	GetCookieName(void);
	
	void	SetCookieVal(const char* value);
	char*	GetCookieVal(void);
	
	void	SetCookiePath(const char* path);
	char*	GetCookiePath(void);
	
	void	SetCookieExpires(const char* expires);
	char*	GetCookieExpires(void);
};

class CDBUserCookies
{
	static char* m_sDB;

protected:
	int	CheckDomainMatch(const char* sCookieDomain, const char* Host);
	int	GetCrackedCookie(char* raw_cookie, CCookie** pCookie);
	int	MatchTail(const char* sString, const char* sTail, int nCaseSensitive);
	time_t	ParseDate(const char* dateString);

public:
	char*	BuildCookies(const CParsedUrl& parURL, int nUserID);
	void	PurgeDBUserCookies(int nUserID);
	void	StoreDBUserCookies(const CParsedUrl& parURL, std::vector <CCookie*> cookiesAr, int nUserID);
};

bool IsNumericAddress(const char* pAddr);
