////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once

class CPsiphonMessage
{
	char* 	m_sMessage;
	char* 	m_sIP;
	char* 	m_sURI;
	int		m_nUserID;

	int		m_nLastAccess;
	int		m_nWritten;
	int		m_nWriteTime;
	int		m_nRead;
	int		m_nReadTime;

	char* 	m_sOut;

public:
	CPsiphonMessage();
	CPsiphonMessage(const char* sIn);
	~CPsiphonMessage();

public:
	void	Init();
	void	Out(char*& pOut);

	bool	Parse(const char* sIn);

	char*	GetMessage();
	char*	GetIP();
	char*	GetURI();
	int		GetUserID();
	int		GetLastAccess();
	int		GetWritten();
	int		GetRead();
	int		GetWriteTime();
	int		GetReadTime();

	void	SetMessage(const char*);
	void	SetIP(const char* _sIP);
	void	SetURI(const char* _sURI);
	void	SetUserID(int _nUserID);
	void	SetLastAccess(int _nLastAccess);
	void	SetWritten(int _nWritten);
	void	SetRead(int _nRead);
	void	SetWriteTime(int _nWriteTime);
	void	SetReadTime(int _nReadTime);
};

extern const char* PSIPHON_MESSAGE;
extern const char* PSIPHON_MESSAGE_REQUEST;

