////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#include "strfunc.h"
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define _T(X) X

int GetStrLength(int nNumber)
{
	char p[20];
	int nLen = _snprintf(p, 20, _T("%d"), nNumber);
	return nLen;
}

int GetStrLength(const char* pStr)
{
	if(pStr == NULL)
		return 0;

	return strlen(pStr);
}

bool StartsWith(const char* s1, const char* s2)
{
	if(s1 == NULL || *s1 == 0 || s2 == NULL || *s2 == 0)
		return false;

	int n_s1_len = strlen(s1);
	int n_s2_len = strlen(s2);

	if(n_s1_len < n_s2_len)
		return false;

	if(strncmp(s1, s2, n_s2_len) == 0)
		return true;

	return false;
}

unsigned int strnlen(const char *string, unsigned int maxlen)
{
   const char* end =(const char*)memchr(string, '\0', maxlen);
   return end ? (unsigned int) (end - string) : maxlen;
}

#ifdef _WIN32

char* strndup(const char *s, unsigned int n)
{
	unsigned int len = strnlen(s, n);
	char* pNew = new char[len + 1];

	if (pNew == NULL)
		return NULL;

	pNew[len] = '\0';
	
	return (char*) memcpy(pNew, s, len);
}
#endif

char* stristr(const char* String, const char* Pattern)
{
	char* pptr, * sptr, * start;

	for(start = (char*)String;*start != 0;start++)
	{
		// find start of pattern in string 
		for(;((*start != 0) && (toupper(*start) != toupper(*Pattern)));start++)
			;
		if(0 == *start)
			return NULL;

		pptr = (char*)Pattern;
		sptr = (char*)start;

		while(toupper(*sptr) == toupper(*pptr))
		{
			sptr++;
			pptr++;

			// if end of pattern then pattern was found 

			if(0 == *pptr)
				return (start);
		}
	}
	return NULL;
}


