////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////
#ifdef _ENABLE_TRACE

#include "tracer.h"	
#include <stdio.h>
#include <string.h>
#include "strfunc.h"

int CTracer::m_nLevel = 1;

#define TRACE_FUNC _T("c:\\psiphon.txt")

CTracer::CTracer(const char* _pFuncName) : m_pFuncName(_pFuncName)
{
	char sMsg[255];
	int nLen = _snprintf(sMsg, 255, _T("START %s"), m_pFuncName);
	if(nLen <= 0 || nLen >= 255)
		return;

	LOG(sMsg);	

	m_nLevel++;
}

CTracer::~CTracer()
{
	m_nLevel--;

	char sMsg[255];
	int nLen = _snprintf(sMsg, 255, _T("END %s"), m_pFuncName);
	if(nLen <= 0 || nLen >= 255)
		return;

	LOG(sMsg);	
	LOG("");
}

void CTracer::RESET()
{
	FILE* pFile = fopen(TRACE_FUNC, _T("w"));
	fclose(pFile);
	m_nLevel = 1;
}

void CTracer::LOG(const char* sMsg)
{
	FILE* pFile = fopen(TRACE_FUNC, _T("a+"));

	//count tabs
	char chTabs[255];
	chTabs[0] = '\0';

	for(int i = 0;i < m_nLevel;i++)
		strcat(chTabs, _T("\t"));
	//
	char sLine[255];
	int nLen = _snprintf(sLine, 255, _T("%s%s"), chTabs, sMsg);
	if(nLen <= 0 || nLen >= 255)
		return;

	fwrite(sLine, sizeof(char), strlen(sLine), pFile);

	char eol[2] =
	{
		13, 10
	};
	fwrite(eol, sizeof(char), 2, pFile);

	fclose(pFile);
};

#endif

