%{
#include "TokensDefs.h"
%}

%x S_IMPORT
%x S_URL
%x S_STYLE_END_TAG
%x ST_VALUE_ONE_QUOTED
%x ST_VALUE_DOUBLE_QUOTED
%x ST_VALUE_NOT_QUOTED
%x END_OF_STYLE
%x ST_EOF

%option prefix="CSS"
%option noyywrap


IMPORT "@import"
URL "url"
STYLEND "</style"
WHITESPACE [\n\r\ \t\b\012]*
QUOT '
DOUBLEQUOT \"
CLOSE "/"
ENDTAG (>|{CLOSE}>)
ONEQUOTEDSTRING [^']*
DOUBLEQUOTEDSTRING [^\"]*
NOTQUOTEDSTRING [^\n\r\ \t\b\012)]*


%%
<INITIAL><ST_EOF> {return T_EOF;}

<<EOF>> {return T_EOF;}

<INITIAL>{WHITESPACE} {BEGIN(INITIAL); return (T_IN_STYLE);}

<INITIAL>{STYLEND}{ENDTAG} {BEGIN(INITIAL);return (T_STYLE_END);}
<INITIAL>{URL} {BEGIN (S_URL);return(T_IN_STYLE);}
<INITIAL>{IMPORT} {BEGIN (S_IMPORT);return(T_IN_STYLE);}

<S_IMPORT>{WHITESPACE}*{URL} {BEGIN (S_URL);return(T_IN_STYLE);}


<S_IMPORT>{WHITESPACE}*"("*{QUOT}{WHITESPACE}* {BEGIN (ST_VALUE_ONE_QUOTED);return(T_IN_STYLE);}
<S_IMPORT>{WHITESPACE}*"("*{DOUBLEQUOT}{WHITESPACE}* {BEGIN (ST_VALUE_DOUBLE_QUOTED);return(T_IN_STYLE);}
<S_IMPORT>{WHITESPACE}*"("{WHITESPACE}* {BEGIN (ST_VALUE_NOT_QUOTED);return(T_IN_STYLE);}
<S_IMPORT>.|\n {BEGIN(INITIAL);return T_IN_STYLE;}


<S_URL>{WHITESPACE}*"("*{WHITESPACE}*{QUOT}{WHITESPACE}* {BEGIN (ST_VALUE_ONE_QUOTED);return(T_IN_STYLE);}
<S_URL>{WHITESPACE}*"("*{WHITESPACE}*{DOUBLEQUOT}{WHITESPACE}* {BEGIN (ST_VALUE_DOUBLE_QUOTED);return(T_IN_STYLE);}
<S_URL>{WHITESPACE}*"("{WHITESPACE}* {BEGIN (ST_VALUE_NOT_QUOTED);return(T_IN_STYLE);}
<S_URL>.|\n {BEGIN(INITIAL);return T_IN_STYLE;}

<ST_VALUE_ONE_QUOTED>{ONEQUOTEDSTRING} {BEGIN(INITIAL); return(T_STYLE_URL);}
<ST_VALUE_DOUBLE_QUOTED>{DOUBLEQUOTEDSTRING} {BEGIN(INITIAL); return(T_STYLE_URL);}
<ST_VALUE_NOT_QUOTED>{NOTQUOTEDSTRING} {BEGIN(INITIAL); return(T_STYLE_URL);}

.|\n	{BEGIN(INITIAL);return T_IN_STYLE;}
%%