%{
#include "TokensDefs.h"
%}
%x ST_TAG
%x ST_TAG_PARAMETER
%x ST_TAG_PARAMETER_VALUE
%x ST_COMMENT
%x ST_VALUE_ONE_QUOTED
%x ST_VALUE_DOUBLE_QUOTED
%x ST_EOF
%x S_SCRIPT
%x S_SCRIPT_APOS
%x S_SCRIPT_APOS_ESC
%x S_SCRIPT_STRING
%x S_SCRIPT_STRING_ESC
%x S_SCRIPT_COMMENT
%x S_SCRIPT_MCOMMENT
%x S_STYLE
%x S_IN_STYLE
%x S_META_TAG
%x S_META_REFRESH_URL

%option prefix="HTML"
%option noyywrap


ANYPARAMETER [^<>= \r\n\t]*
CLOSE "/"
WORD [^'\"\r\n\t<> ]*
WHITESPACE [\n\r\ \t\b\012]*
NOT_WHITESPACE [^\n\r\ \t\b\012]+
TAGNAME [a-zA-Z!0-9:_\.-]+
NOTTAGNAME [^a-zA-Z!0-9:_\.-]*
QUOT '
DOUBLEQUOT \"
ENDTAG (>|{CLOSE}>)
BEGINTAG "<"
TAGPARAMETER {TAGNAME}
ONEQUOTEDSTRING [^']*
DOUBLEQUOTEDSTRING [^\"]*
COMMENT_BEGIN "<!--"
COMMENT_TEXT [^>-]
COMMENT_END "-->"
ANY (.|[\n])


%%
<INITIAL><ST_EOF> {return T_EOF;}

<<EOF>> {return T_EOF;}

<INITIAL>{BEGINTAG}	{BEGIN(ST_TAG); return T_BEGIN_TAG;}

  /***********************NOSCRIPT ************************/
  
<INITIAL>"</noscript"[^>]*{ENDTAG}	{BEGIN(INITIAL); return T_NOSCRIPT_END;}

<INITIAL>"<noscript"[^>]*{ENDTAG}	{BEGIN(INITIAL); return T_NOSCRIPT;}
	
	/***********************END NOSCRIPT ************************/

  /***********************OBJECTS ************************/
  
<INITIAL>"</object"[^>]*{ENDTAG}	{BEGIN(INITIAL); return T_OBJECT;}
<INITIAL>"<object"[^>]*{ENDTAG}	{BEGIN(INITIAL); return T_OBJECT;}

<INITIAL>"<param"[^>]*{ENDTAG}	{BEGIN(INITIAL); return T_OBJECT;}

<INITIAL>"<embed"[^>]*{ENDTAG}	{BEGIN(INITIAL); return T_OBJECT;}
<INITIAL>"</embed"[^>]*{ENDTAG}	{BEGIN(INITIAL); return T_OBJECT;}

<INITIAL>"<applet"[^>]*{ENDTAG}	{BEGIN(INITIAL); return T_OBJECT;}
<INITIAL>"</applet"[^>]*{ENDTAG}	{BEGIN(INITIAL); return T_OBJECT;}
	
	/***********************END OBJECTS ************************/
%{
/*
<INITIAL>{COMMENT_BEGIN}	{BEGIN(ST_COMMENT);return T_BEGIN_COMMENT;}
*/
%}

<ST_TAG>{CLOSE}	{BEGIN(INITIAL); return T_CLOSE_TAG;}

<ST_TAG>{TAGNAME}	{
if(stricmp(yytext , "script")==0)
	{BEGIN(S_SCRIPT);return(T_SCRIPT);}
else if(stricmp(yytext , "style")==0)
	{BEGIN(S_STYLE); return(T_TAG_NAME);}
else if(stricmp(yytext , "meta")==0)
	{BEGIN(S_META_TAG); return(T_TAG_NAME);}
else 
	{BEGIN(ST_TAG_PARAMETER);return T_TAG_NAME;}
}

  /*********************** SCRIPT ************************/
<S_SCRIPT,S_SCRIPT_COMMENT><\/{WHITESPACE}*[Ss][Cc][Rr][Ii][Pp][Tt]{WHITESPACE}*> {
    BEGIN(INITIAL);
    return(T_SCRIPT);
}

<S_SCRIPT>[^/'"<]+ {
    return(T_SCRIPT);
}

<S_SCRIPT>\' {
    BEGIN(S_SCRIPT_APOS);
    return(T_SCRIPT);
}

<S_SCRIPT>\" {
    BEGIN(S_SCRIPT_STRING);
    return(T_SCRIPT);
}

<S_SCRIPT>\/\/ {
    BEGIN(S_SCRIPT_COMMENT);
    return(T_SCRIPT);
}

<S_SCRIPT>\/\* {
    BEGIN(S_SCRIPT_MCOMMENT);
    return(T_SCRIPT);
}

<S_SCRIPT>\/[^*/] {
    return(T_SCRIPT);
}

<S_SCRIPT,S_SCRIPT_COMMENT></[^/] {
    return(T_SCRIPT);
}

<S_SCRIPT,S_SCRIPT_COMMENT><\/{WHITESPACE}*/[^Ss\n\r\ \t\b\012] {
    return(T_SCRIPT);
}

<S_SCRIPT,S_SCRIPT_COMMENT><\/{WHITESPACE}*[Ss]/[^Cc] {
    return(T_SCRIPT);
}

<S_SCRIPT,S_SCRIPT_COMMENT><\/{WHITESPACE}*[Ss][Cc]/[^Rr] {
    return(T_SCRIPT);
}

<S_SCRIPT,S_SCRIPT_COMMENT><\/{WHITESPACE}*[Ss][Cc][Rr]/[^Ii] {
    return(T_SCRIPT);
}

<S_SCRIPT,S_SCRIPT_COMMENT><\/{WHITESPACE}*[Ss][Cc][Rr][Ii]/[^Pp] {
    return(T_SCRIPT);
}

<S_SCRIPT,S_SCRIPT_COMMENT><\/{WHITESPACE}*[Ss][Cc][Rr][Ii][Pp]/[^Tt] {
    return(T_SCRIPT);
}

<S_SCRIPT,S_SCRIPT_COMMENT><\/{WHITESPACE}*[Ss][Cc][Rr][Ii][Pp][Tt]{WHITESPACE}*/[^>\n\r\ \t\b\012] {
    BEGIN(INITIAL);
    return(T_SCRIPT);
}

<S_SCRIPT>. {
    BEGIN(INITIAL);
    return(T_SCRIPT);
}

<S_SCRIPT_APOS>\\ {
    BEGIN(S_SCRIPT_APOS_ESC);
    return(T_SCRIPT);
}

<S_SCRIPT_APOS>[^\\']+ {
    return(T_SCRIPT);
}

<S_SCRIPT_APOS>\' {
    BEGIN(S_SCRIPT);
    return(T_SCRIPT);
}

<S_SCRIPT_APOS_ESC>. {
    BEGIN(S_SCRIPT_APOS);
    return(T_SCRIPT);
}

<S_SCRIPT_STRING>\\ {
    BEGIN(S_SCRIPT_STRING_ESC);
    return(T_SCRIPT);
}

<S_SCRIPT_STRING>[^\\"]+ {
    return(T_SCRIPT);
}

<S_SCRIPT_STRING>\" {
    BEGIN(S_SCRIPT);
    return(T_SCRIPT);
}

<S_SCRIPT_STRING_ESC>. {
    BEGIN(S_SCRIPT_STRING);
    return(T_SCRIPT);
}

<S_SCRIPT_COMMENT>[^\-\r\n<]+ {
    return(T_SCRIPT);
}

<S_SCRIPT_COMMENT>[\r\n] {
    BEGIN(S_SCRIPT);
    return(T_SCRIPT);
}

<S_SCRIPT_COMMENT>-([^-\r\n]+|-[^>\r\n]+) {
    return(T_SCRIPT);
}

<S_SCRIPT_COMMENT>--> {
    BEGIN(S_SCRIPT);
    return(T_SCRIPT);
}

<S_SCRIPT_COMMENT>. {
    BEGIN(S_SCRIPT);
    return(T_SCRIPT);
}

<S_SCRIPT_MCOMMENT>[^*]+|\* {
    return(T_SCRIPT);
}

<S_SCRIPT_MCOMMENT>\*\/ {
    BEGIN(S_SCRIPT);
    return(T_SCRIPT);
}
  /***********************END SCRIPT ************************/

  /***********************HTML STYLE ************************/

<S_STYLE>[^>]*{ENDTAG} {BEGIN(INITIAL); return T_IN_STYLE;}

  /***********************END HTML STYLE ************************/

  /***********************META REFRESH ************************/

<S_META_TAG>{WHITESPACE}*"HTTP-EQUIV"{WHITESPACE}*={WHITESPACE}*["\']*"Refresh"["|']*{WHITESPACE}*"CONTENT"{WHITESPACE}*"="{WHITESPACE}*["|']{WHITESPACE}*[0-9]*{WHITESPACE}*";"{WHITESPACE}*"URL"{WHITESPACE}*"="{WHITESPACE}* {BEGIN(S_META_REFRESH_URL); return T_TAG_ADDITIONS;}
  
<S_META_TAG>{WHITESPACE}*"CONTENT"{WHITESPACE}*"="{WHITESPACE}*["|']{WHITESPACE}*[0-9]*{WHITESPACE}*";"{WHITESPACE}*"URL"{WHITESPACE}*"="{WHITESPACE}*"HTTP-EQUIV"{WHITESPACE}*={WHITESPACE}*["|']*"Refresh"["|']*{WHITESPACE}* {BEGIN(S_META_REFRESH_URL); return T_TAG_ADDITIONS;}

<S_META_REFRESH_URL>[^ '"]+ {BEGIN(ST_TAG_PARAMETER); return T_META_REFRESH_URL;}

<S_META_TAG>{WHITESPACE}* {BEGIN(ST_TAG_PARAMETER); return T_TAG_ADDITIONS;}

  /***********************END META REFRESH ************************/
  
  /***********************MAIN HTML ************************/

<ST_TAG>{ENDTAG} {return T_ERROR;}

<ST_TAG>{NOTTAGNAME} 	{BEGIN(INITIAL);return T_ERROR;}

%{
/*
<ST_COMMENT>{COMMENT_END}	{BEGIN(INITIAL);return T_END_COMMENT;}

<ST_COMMENT>{COMMENT_TEXT}*	{return T_TAG_ADDITIONS;}

<ST_COMMENT>">"	{return T_TAG_ADDITIONS;}

<ST_COMMENT>"-"	{return T_TAG_ADDITIONS;}
*/
%}

<ST_TAG_PARAMETER>{TAGPARAMETER}	{return T_TAG_PARAMETER;}

<ST_TAG_PARAMETER>{WHITESPACE}*={WHITESPACE}*	{BEGIN(ST_TAG_PARAMETER_VALUE);return T_NOTHING;}

<ST_TAG_PARAMETER>{WHITESPACE}* {return T_TAG_ADDITIONS;}

<ST_TAG_PARAMETER>{ENDTAG}	{BEGIN(INITIAL); return T_END_TAG;}

<ST_TAG_PARAMETER>{BEGINTAG}	{BEGIN(ST_TAG);return T_BEGIN_TAG;}

<ST_TAG_PARAMETER>{ANYPARAMETER} {return T_TAG_ADDITIONS;}

<ST_TAG_PARAMETER_VALUE>{QUOT}{WHITESPACE}* 	{BEGIN(ST_VALUE_ONE_QUOTED);return T_QUOT;}

<ST_TAG_PARAMETER_VALUE>{DOUBLEQUOT}{WHITESPACE}* {BEGIN(ST_VALUE_DOUBLE_QUOTED);return T_DOUBLEQUOT;}

<ST_TAG_PARAMETER_VALUE>{BEGINTAG} 	{BEGIN(ST_TAG);return T_BEGIN_TAG;}

<ST_TAG_PARAMETER_VALUE>{WORD} 	{BEGIN(ST_TAG_PARAMETER);return T_TAG_PARAMETER_VALUE;}

<ST_TAG_PARAMETER_VALUE>{WHITESPACE}*	{BEGIN(ST_TAG_PARAMETER);return T_NOTHING;}

<ST_VALUE_ONE_QUOTED>{ONEQUOTEDSTRING} 	{BEGIN(ST_VALUE_ONE_QUOTED);return T_TAG_PARAMETER_VALUE;}

<ST_VALUE_ONE_QUOTED>{QUOT}		{BEGIN(ST_TAG_PARAMETER);return T_TAG_PARAMETER_VALUE_EMPTY;}

<ST_VALUE_DOUBLE_QUOTED>{DOUBLEQUOTEDSTRING} 	{BEGIN(ST_VALUE_DOUBLE_QUOTED);return T_TAG_PARAMETER_VALUE;}

<ST_VALUE_DOUBLE_QUOTED>{DOUBLEQUOT} 	{BEGIN(ST_TAG_PARAMETER);return T_TAG_PARAMETER_VALUE_EMPTY;}

<INITIAL>[^<]+ { return T_TEXT;}

<INITIAL><[^\012 \t\b\r\nA-Za-z!?/] { return T_TEXT;}

<INITIAL><{WHITESPACE}+[^A-Za-z/] { return T_TEXT;}

<INITIAL><![^- dD\[] { return T_TEXT;}

. {BEGIN(INITIAL);}


%%
