////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#define yyFlexLexer CSSFlexLexer

/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /home/daffy/u0/vern/flex/RCS/flex.skl,v 2.91 96/09/10 16:58:48 vern Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5



/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <iosfwd>
using namespace std;
//class istream;
//#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
#pragma warn -rch
#pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state* YY_BUFFER_STATE;

extern int yyleng;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
{
	istream* 	yy_input_file;

	char* 		yy_ch_buf;		/* input buffer */
	char* 		yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t	yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int			yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int			yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int			yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int			yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int			yy_fill_buffer;

	int			yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
};


/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer



static void* yy_flex_alloc YY_PROTO((yy_size_t));
static void* yy_flex_realloc YY_PROTO((void *, yy_size_t));
static void yy_flex_free YY_PROTO((void*));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)


#define yywrap() 1
#define YY_SKIP_YYWRAP
typedef unsigned char YY_CHAR;
#define yytext_ptr yytext
#define YY_INTERACTIVE

#include "FlexLexer.h"


/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 19
#define YY_END_OF_BUFFER 20
static yyconst short int yy_accept[193] =
{
	0, 2, 2, 0, 0, 0, 0, 0, 0, 15, 15, 16, 16, 17, 17, 0, 0, 0, 0, 20, 18, 2, 18, 18, 18, 18, 10, 10, 8, 7, 9, 10, 10, 14, 14, 12, 11, 13, 19, 15, 16, 17, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 7, 9, 0, 0, 8, 7, 9, 0, 0, 0, 0, 0, 0, 0, 12, 11, 13, 12, 11, 13, 0, 15, 16, 17, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 4, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 1, 0, 0, 0, 0, 5, 0, 0, 5, 0, 0
} ;

static yyconst int yy_ec[256] =
{
	0, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 1, 5, 6, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 7, 1, 1, 1, 1, 8, 9, 10, 1, 1, 1, 1, 1, 11, 12, 1, 13, 1, 14, 15, 16, 17, 1, 18, 1, 1, 19, 1, 20, 1, 1, 1, 1, 23, 24, 25, 26, 1, 1, 27, 1, 1, 28, 29, 1, 30, 31, 1, 32, 33, 34, 35, 1, 1, 1, 36, 1, 1, 21, 1, 1, 22, 1, 1, 1, 23, 24, 25, 26, 1, 1, 27, 1, 1, 28, 29, 1, 30, 31, 1, 32, 33, 34, 35, 1, 1, 1, 36, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
} ;

static yyconst int yy_meta[37] =
{
	0, 1, 2, 2, 2, 1, 2, 3, 4, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
} ;

static yyconst short int yy_base[203] =
{
	0, 0, 34, 68, 102, 136, 144, 0, 0, 493, 477, 457, 431, 5, 10, 0, 0, 0, 0, 432, 562, 20, 6, 142, 4, 9, 562, 176, 40, 45, 210, 17, 24, 562, 218, 56, 61, 226, 562, 0, 0, 0, 76, 387, 380, 69, 395, 394, 390, 372, 66, 36, 78, 67, 84, 45, 0, 111, 116, 0, 114, 70, 130, 158, 164, 164, 113, 368, 364, 174, 72, 0, 190, 196, 0, 201, 234, 367, 239, 0, 0, 0, 335, 341, 237, 252, 279, 247, 323, 315, 255, 91, 254, 314, 309, 248, 562, 262, 309, 263, 294, 284, 275, 562, 279, 232, 240, 278, 295, 297, 290, 339, 293, 238, 232, 305, 103, 308, 368, 320, 216, 208, 316, 305, 334, 394, 336, 200, 192, 181, 171, 339, 345, 354, 350, 420, 352, 169, 161, 369, 142, 365, 374, 376, 400, 173, 395, 390, 405, 424, 156, 149, 194, 419, 412, 423, 448, 428, 142, 128, 432, 562, 281, 443, 123, 323, 444, 93, 154, 34, 376, 449, 458, 455, 488, 456, 36, 17, 432, 460, 8, 562, 562, 461, 466, 478, 472, 492, 471, 488, 1, 487, 562, 522, 526, 530, 534, 538, 542, 546, 550, 553, 557
} ;

static yyconst short int yy_def[203] =
{
	0, 193, 193, 194, 194, 195, 195, 196, 196, 197, 197, 198, 198, 199, 199, 196, 196, 196, 196, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 200, 201, 202, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 27, 192, 192, 30, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 34, 192, 192, 37, 192, 192, 37, 192, 200, 201, 202, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 78, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 0, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192
} ;

static yyconst short int yy_nxt[599] =
{
	0, 192, 21, 21, 21, 161, 21, 38, 38, 38, 192, 38, 38, 38, 38, 38, 38, 43, 192, 22, 38, 23, 42, 42, 42, 52, 42, 24, 181, 66, 54, 187, 67, 53, 68, 25, 21, 21, 21, 44, 21, 55, 62, 62, 62, 69, 62, 63, 63, 63, 187, 63, 61, 22, 182, 23, 70, 54, 75, 75, 75, 24, 75, 76, 76, 76, 95, 76, 55, 25, 27, 27, 27, 96, 27, 28, 29, 30, 42, 42, 42, 84, 42, 46, 47, 48, 49, 52, 90, 31, 87, 69, 88, 102, 89, 53, 92, 103, 91, 93, 103, 94, 70, 32, 27, 27, 27, 53, 27, 28, 29, 30, 115, 62, 62, 62, 55, 62, 63, 63, 63, 116, 63, 31, 139, 97, 66, 96, 67, 67, 68, 68, 62, 62, 62, 140, 62, 32, 34, 34, 34, 174, 34, 35, 36, 37, 34, 34, 34, 61, 34, 35, 36, 37, 45, 174, 46, 47, 48, 49, 63, 63, 63, 160, 63, 180, 64, 64, 64, 50, 64, 57, 58, 65, 181, 169, 161, 51, 56, 56, 56, 168, 56, 57, 58, 59, 99, 156, 67, 100, 68, 101, 75, 75, 75, 156, 75, 60, 76, 76, 76, 151, 76, 75, 75, 75, 70, 75, 88, 150, 89, 61, 64, 64, 64, 149, 64, 57, 58, 65, 71, 71, 71, 149, 71, 72, 73, 74, 77, 77, 77, 144, 77, 72, 73, 78, 76, 76, 76, 144, 76, 104, 104, 104, 135, 104, 72, 73, 78, 107, 135, 46, 47, 48, 49, 50, 50, 50, 108, 110, 119, 88, 120, 89, 121, 130, 117, 112, 129, 93, 113, 94, 114, 52, 122, 124, 96, 67, 100, 68, 101, 53, 51, 51, 51, 109, 91, 126, 192, 127, 131, 128, 46, 47, 48, 49, 93, 125, 94, 50, 54, 51, 132, 103, 88, 134, 89, 125, 113, 61, 114, 55, 61, 61, 61, 123, 52, 136, 54, 137, 141, 138, 118, 93, 53, 94, 69, 118, 145, 55, 69, 67, 143, 68, 120, 116, 121, 70, 100, 111, 101, 70, 53, 53, 53, 133, 146, 111, 148, 100, 127, 101, 128, 46, 47, 48, 49, 152, 53, 88, 90, 89, 153, 106, 155, 113, 137, 114, 138, 105, 91, 55, 55, 55, 142, 90, 192, 162, 55, 98, 93, 157, 94, 98, 158, 91, 159, 86, 163, 95, 120, 113, 121, 114, 70, 95, 96, 70, 70, 70, 147, 140, 96, 96, 96, 96, 164, 165, 85, 86, 100, 102, 101, 85, 83, 102, 91, 166, 103, 127, 82, 128, 103, 91, 91, 91, 154, 103, 103, 103, 167, 170, 192, 115, 113, 171, 114, 137, 38, 138, 173, 115, 116, 158, 175, 159, 120, 176, 121, 177, 116, 116, 116, 116, 172, 178, 179, 120, 127, 121, 128, 183, 116, 137, 38, 138, 161, 184, 186, 139, 158, 176, 159, 177, 127, 137, 128, 138, 188, 139, 140, 158, 140, 159, 189, 38, 158, 176, 159, 177, 140, 140, 140, 140, 185, 161, 161, 161, 190, 160, 191, 38, 176, 176, 177, 177, 192, 192, 192, 160, 192, 192, 161, 192, 192, 192, 192, 192, 192, 192, 192, 192, 161, 20, 20, 20, 20, 26, 26, 26, 26, 33, 33, 33, 33, 38, 38, 38, 38, 39, 39, 39, 39, 40, 40, 40, 40, 41, 41, 41, 41, 79, 79, 79, 80, 80, 192, 80, 81, 192, 81, 81, 19, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192
} ;

static yyconst short int yy_chk[599] =
{
	0, 0, 1, 1, 1, 190, 1, 13, 13, 13, 0, 13, 14, 14, 14, 13, 14, 22, 0, 1, 14, 1, 21, 21, 21, 24, 21, 1, 180, 31, 25, 177, 31, 24, 31, 1, 2, 2, 2, 22, 2, 25, 28, 28, 28, 32, 28, 29, 29, 29, 176, 29, 31, 2, 169, 2, 32, 51, 35, 35, 35, 2, 35, 36, 36, 36, 55, 36, 51, 2, 3, 3, 3, 55, 3, 3, 3, 3, 42, 42, 42, 45, 42, 45, 45, 45, 45, 50, 53, 3, 52, 61, 52, 70, 52, 50, 54, 167, 53, 54, 70, 54, 61, 3, 4, 4, 4, 52, 4, 4, 4, 4, 91, 57, 57, 57, 54, 57, 58, 58, 58, 91, 58, 4, 116, 66, 60, 164, 66, 60, 66, 60, 62, 62, 62, 116, 62, 4, 5, 5, 5, 159, 5, 5, 5, 5, 6, 6, 6, 60, 6, 6, 6, 6, 23, 158, 23, 23, 23, 23, 63, 63, 63, 140, 63, 168, 64, 64, 64, 23, 64, 65, 65, 65, 168, 151, 140, 23, 27, 27, 27, 150, 27, 27, 27, 27, 69, 138, 145, 69, 145, 69, 72, 72, 72, 137, 72, 27, 73, 73, 73, 130, 73, 75, 75, 75, 69, 75, 152, 129, 152, 27, 30, 30, 30, 128, 30, 30, 30, 30, 34, 34, 34, 127, 34, 34, 34, 34, 37, 37, 37, 121, 37, 37, 37, 37, 76, 76, 76, 120, 76, 78, 78, 78, 114, 78, 78, 78, 78, 84, 113, 84, 84, 84, 84, 85, 85, 85, 85, 87, 95, 87, 95, 87, 95, 106, 92, 90, 105, 92, 90, 92, 90, 85, 97, 99, 95, 97, 99, 97, 99, 85, 86, 86, 86, 86, 90, 102, 104, 102, 107, 102, 107, 107, 107, 107, 162, 101, 162, 108, 86, 109, 110, 102, 110, 112, 110, 100, 112, 123, 112, 86, 98, 98, 98, 98, 108, 115, 109, 115, 117, 115, 94, 117, 108, 117, 123, 93, 122, 109, 98, 122, 119, 122, 119, 115, 119, 123, 165, 89, 165, 98, 111, 111, 111, 111, 124, 88, 126, 124, 126, 124, 126, 131, 131, 131, 131, 132, 133, 132, 111, 132, 134, 83, 136, 134, 136, 134, 136, 82, 111, 118, 118, 118, 118, 133, 77, 141, 142, 68, 141, 139, 141, 67, 139, 133, 139, 49, 143, 118, 143, 170, 143, 170, 147, 142, 118, 125, 125, 125, 125, 139, 142, 144, 144, 144, 144, 146, 48, 47, 146, 147, 146, 46, 44, 125, 154, 148, 147, 148, 43, 148, 125, 135, 135, 135, 135, 149, 149, 149, 149, 153, 19, 154, 153, 155, 153, 155, 12, 155, 157, 135, 154, 157, 160, 157, 178, 160, 178, 160, 135, 156, 156, 156, 156, 163, 166, 163, 166, 163, 166, 171, 172, 171, 11, 171, 160, 173, 175, 156, 173, 175, 173, 175, 179, 183, 179, 183, 184, 172, 156, 184, 185, 184, 186, 10, 188, 186, 188, 186, 172, 174, 174, 174, 174, 187, 187, 187, 187, 185, 189, 9, 191, 189, 191, 189, 0, 0, 0, 174, 0, 0, 185, 0, 0, 0, 0, 0, 0, 0, 0, 0, 174, 193, 193, 193, 193, 194, 194, 194, 194, 195, 195, 195, 195, 196, 196, 196, 196, 197, 197, 197, 197, 198, 198, 198, 198, 199, 199, 199, 199, 200, 200, 200, 201, 201, 0, 201, 202, 0, 202, 202, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192
} ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
#define INITIAL 0
#include "tokensDefs.h"
#define S_IMPORT 1

#define S_URL 2

#define S_STYLE_END_TAG 3

#define ST_VALUE_ONE_QUOTED 4

#define ST_VALUE_DOUBLE_QUOTED 5

#define ST_VALUE_NOT_QUOTED 6

#define END_OF_STYLE 7

#define ST_EOF 8


/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO((void));
#else
extern int yywrap YY_PROTO((void));
#endif
#endif


#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO((char *, yyconst char *, int));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO((yyconst char*));
#endif

#ifndef YY_NO_INPUT
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int* yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO((int new_state));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO((void));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO((void));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
#define ECHO LexerOutput( yytext, yyleng )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( (result = LexerInput( (char *) buf, max_size )) < 0 ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) LexerError( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yyFlexLexer::yylex()
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

YY_DECL
{
	register yy_state_type yy_current_state;
	register char* yy_cp, * yy_bp;
	register int yy_act;



	if(yy_init)
	{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if(!yy_start)
			yy_start = 1;	/* first start state */

		if(!yyin)
			yyin = &cin;

		if(!yyout)
			yyout = &cout;

		if(!yy_current_buffer)
			yy_current_buffer = yy_create_buffer(yyin, YY_BUF_SIZE);

		yy_load_buffer_state();
	}

	while(1)		/* loops until end-of-file is reached */
	{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
								 * the current run.
								 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
		yy_match:
		do
		{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if(yy_accept[yy_current_state])
			{
				yy_last_accepting_state = yy_current_state;
				yy_last_accepting_cpos = yy_cp;
			}
			while(yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
			{
				yy_current_state = (int)yy_def[yy_current_state];
				if(yy_current_state >= 193)
					yy_c = yy_meta[(unsigned int) yy_c];
			}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
		}
		while(yy_base[yy_current_state] != 562);

		yy_find_action : yy_act = yy_accept[yy_current_state];
		if(yy_act == 0)
		{
			/* have to back up */
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			yy_act = yy_accept[yy_current_state];
		}

		YY_DO_BEFORE_ACTION;


		do_action:	/* This label is used only to access EOF actions. */


		switch(yy_act)
		{
			/* beginning of action switch */
		case 0:
			/* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = yy_hold_char;
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			goto yy_find_action;

		case 1:
			YY_RULE_SETUP
			{
				return T_EOF;
			}
			YY_BREAK
		case YY_STATE_EOF(INITIAL):
		case YY_STATE_EOF(S_IMPORT):
		case YY_STATE_EOF(S_URL):
		case YY_STATE_EOF(S_STYLE_END_TAG):
		case YY_STATE_EOF(ST_VALUE_ONE_QUOTED):
		case YY_STATE_EOF(ST_VALUE_DOUBLE_QUOTED):
		case YY_STATE_EOF(ST_VALUE_NOT_QUOTED):
		case YY_STATE_EOF(END_OF_STYLE):
		case YY_STATE_EOF(ST_EOF):
			{
				return T_EOF;
			}
			YY_BREAK
		case 2:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return (T_IN_STYLE);
			}
			YY_BREAK
		case 3:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL);return (T_STYLE_END);
			}
			YY_BREAK
		case 4:
			YY_RULE_SETUP
			{
				BEGIN(S_URL);return(T_IN_STYLE);
			}
			YY_BREAK
		case 5:
			YY_RULE_SETUP
			{
				BEGIN(S_IMPORT);return(T_IN_STYLE);
			}
			YY_BREAK
		case 6:
			YY_RULE_SETUP
			{
				BEGIN(S_URL);return(T_IN_STYLE);
			}
			YY_BREAK
		case 7:
			YY_RULE_SETUP
			{
				BEGIN(ST_VALUE_ONE_QUOTED);return(T_IN_STYLE);
			}
			YY_BREAK
		case 8:
			YY_RULE_SETUP
			{
				BEGIN(ST_VALUE_DOUBLE_QUOTED);return(T_IN_STYLE);
			}
			YY_BREAK
		case 9:
			YY_RULE_SETUP
			{
				BEGIN(ST_VALUE_NOT_QUOTED);return(T_IN_STYLE);
			}
			YY_BREAK
		case 10:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL);return T_IN_STYLE;
			}
			YY_BREAK
		case 11:
			YY_RULE_SETUP
			{
				BEGIN(ST_VALUE_ONE_QUOTED);return(T_IN_STYLE);
			}
			YY_BREAK
		case 12:
			YY_RULE_SETUP
			{
				BEGIN(ST_VALUE_DOUBLE_QUOTED);return(T_IN_STYLE);
			}
			YY_BREAK
		case 13:
			YY_RULE_SETUP
			{
				BEGIN(ST_VALUE_NOT_QUOTED);return(T_IN_STYLE);
			}
			YY_BREAK
		case 14:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL);return T_IN_STYLE;
			}
			YY_BREAK
		case 15:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return(T_STYLE_URL);
			}
			YY_BREAK
		case 16:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return(T_STYLE_URL);
			}
			YY_BREAK
		case 17:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return(T_STYLE_URL);
			}
			YY_BREAK
		case 18:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL);return T_IN_STYLE;
			}
			YY_BREAK
		case 19:
			YY_RULE_SETUP ECHO;
			YY_BREAK

		case YY_END_OF_BUFFER:
			{
				/* Amount of text matched not including the EOB char. */
				int yy_amount_of_matched_text = (int)(yy_cp - yytext_ptr) - 1;

				/* Undo the effects of YY_DO_BEFORE_ACTION. */
				*yy_cp = yy_hold_char;
				YY_RESTORE_YY_MORE_OFFSET

				if(yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW)
				{
					/* We're scanning a new file or input source.  It's
																						 * possible that this happened because the user
																						 * just pointed yyin at a new source and called
																						 * yylex().  If so, then we have to assure
																						 * consistency between yy_current_buffer and our
																						 * globals.  Here is the right place to do so, because
																						 * this is the first action (other than possibly a
																						 * back-up) that will match for the new input source.
																						 */
					yy_n_chars = yy_current_buffer->yy_n_chars;
					yy_current_buffer->yy_input_file = yyin;
					yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
				}

				/* Note that here we test for yy_c_buf_p "<=" to the position
															 * of the first EOB in the buffer, since yy_c_buf_p will
															 * already have been incremented past the NUL character
															 * (since all states make transitions on EOB to the
															 * end-of-buffer state).  Contrast this with the test
															 * in input().
															 */
				if(yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars])
				{
					/* This was really a NUL. */
					yy_state_type yy_next_state;

					yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

					yy_current_state = yy_get_previous_state();

					/* Okay, we're now positioned to make the NUL
																			 * transition.  We couldn't have
																			 * yy_get_previous_state() go ahead and do it
																			 * for us because it doesn't know how to deal
																			 * with the possibility of jamming (and we don't
																			 * want to build jamming into it because then it
																			 * will run more slowly).
																			 */

					yy_next_state = yy_try_NUL_trans(yy_current_state);

					yy_bp = yytext_ptr + YY_MORE_ADJ;

					if(yy_next_state)
					{
						/* Consume the NUL. */
						yy_cp = ++yy_c_buf_p;
						yy_current_state = yy_next_state;
						goto yy_match;
					}
					else
					{
						yy_cp = yy_c_buf_p;
						goto yy_find_action;
					}
				}
				else
					switch(yy_get_next_buffer())
					{
					case EOB_ACT_END_OF_FILE:
						{
							yy_did_buffer_switch_on_eof = 0;

							if(yywrap())
							{
								/* Note: because we've taken care in
																																				 * yy_get_next_buffer() to have set up
																																				 * yytext, we can now set up
																																				 * yy_c_buf_p so that if some total
																																				 * hoser (like flex itself) wants to
																																				 * call the scanner after we return the
																																				 * YY_NULL, it'll still work - another
																																				 * YY_NULL will get returned.
																																				 */
								yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

								yy_act = YY_STATE_EOF(YY_START);
								goto do_action;
							}
							else
							{
								if(!yy_did_buffer_switch_on_eof)
									YY_NEW_FILE;
							}
							break;
						}

					case EOB_ACT_CONTINUE_SCAN:
						yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

						yy_current_state = yy_get_previous_state();

						yy_cp = yy_c_buf_p;
						yy_bp = yytext_ptr + YY_MORE_ADJ;
						goto yy_match;

					case EOB_ACT_LAST_MATCH:
						yy_c_buf_p = &yy_current_buffer->yy_ch_buf[yy_n_chars];

						yy_current_state = yy_get_previous_state();

						yy_cp = yy_c_buf_p;
						yy_bp = yytext_ptr + YY_MORE_ADJ;
						goto yy_find_action;
					}
				break;
			}

		default:
			YY_FATAL_ERROR("fatal flex scanner internal error--no action found");
		} /* end of action switch */
	} /* end of scanning one token */
} /* end of yylex */

yyFlexLexer::yyFlexLexer(istream* arg_yyin, ostream* arg_yyout)
{
	yyin = arg_yyin;
	yyout = arg_yyout;
	yy_c_buf_p = 0;
	yy_init = 1;
	yy_start = 0;
	yy_flex_debug = 0;
	yylineno = 1;	// this will only get updated if %option yylineno

	yy_did_buffer_switch_on_eof = 0;

	yy_looking_for_trail_begin = 0;
	yy_more_flag = 0;
	yy_more_len = 0;
	yy_more_offset = yy_prev_more_offset = 0;

	yy_start_stack_ptr = yy_start_stack_depth = 0;
	yy_start_stack = 0;

	yy_current_buffer = 0;

#ifdef YY_USES_REJECT
	yy_state_buf = new yy_state_type[YY_BUF_SIZE + 2];
#else
	yy_state_buf = 0;
#endif
}

yyFlexLexer::~yyFlexLexer()
{
	delete yy_state_buf;
	yy_delete_buffer(yy_current_buffer);
}

void yyFlexLexer::switch_streams(istream* new_in, ostream* new_out)
{
	if(new_in)
	{
		yy_delete_buffer(yy_current_buffer);
		yy_switch_to_buffer(yy_create_buffer(new_in, YY_BUF_SIZE));
	}

	if(new_out)
		yyout = new_out;
}

#ifdef YY_INTERACTIVE
int yyFlexLexer::LexerInput(char* buf, int /* max_size */)
#else
int yyFlexLexer::LexerInput( char* buf, int max_size )
#endif
{
	if(yyin->eof() || yyin->fail())
		return 0;

#ifdef YY_INTERACTIVE
	yyin->get(buf[0]);

	if(yyin->eof())
		return 0;

	if(yyin->bad())
		return -1;

	return 1;

#else
	(void)yyin->read(buf, max_size);

	if(yyin->bad())
		return -1;
	else
		return yyin->gcount();
#endif
}

void yyFlexLexer::LexerOutput(const char* buf, int size)
{
	(void)yyout->write(buf, size);
}

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

int yyFlexLexer::yy_get_next_buffer()
{
	register char* dest = yy_current_buffer->yy_ch_buf;
	register char* source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if(yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1])
		YY_FATAL_ERROR("fatal flex scanner internal error--end of buffer missed");

	if(yy_current_buffer->yy_fill_buffer == 0)
	{
		/* Don't try to fill the buffer, so this is an EOF. */
		if(yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1)
		{
			/* We matched a single character, the EOB, so
									 * treat this as a final EOF.
									 */
			return EOB_ACT_END_OF_FILE;
		}
		else
		{
			/* We matched some text prior to the EOB, first
									 * process it.
									 */
			return EOB_ACT_LAST_MATCH;
		}
	}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int)(yy_c_buf_p - yytext_ptr) - 1;

	for(i = 0;i < number_to_move;++i)
		*(dest++) = *(source++);

	if(yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING)
	/* don't do the read, it's not guaranteed to return an EOF,
	* just force an EOF
	*/
		yy_current_buffer->yy_n_chars = yy_n_chars = 0;
	else
	{
		int num_to_read = yy_current_buffer->yy_buf_size - number_to_move - 1;

		while(num_to_read <= 0)
		{
			/* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR("input buffer overflow, can't enlarge buffer because scanner uses REJECT");
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset = (int)(yy_c_buf_p - b->yy_ch_buf);

			if(b->yy_is_our_buffer)
			{
				int new_size = b->yy_buf_size * 2;

				if(new_size <= 0)
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char*)
				/* Include room in for 2 EOB chars. */
				yy_flex_realloc((void*)b->yy_ch_buf, b->yy_buf_size + 2);
			}
			else
			/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if(!b->yy_ch_buf)
				YY_FATAL_ERROR("fatal error - scanner input buffer overflow");

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size - number_to_move - 1;
#endif
		}

		if(num_to_read > YY_READ_BUF_SIZE)
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT((&yy_current_buffer->yy_ch_buf[number_to_move]), yy_n_chars, num_to_read);

		yy_current_buffer->yy_n_chars = yy_n_chars;
	}

	if(yy_n_chars == 0)
	{
		if(number_to_move == YY_MORE_ADJ)
		{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin);
		}
		else
		{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_EOF_PENDING;
		}
	}
	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
}


/* yy_get_previous_state - get the state just before the EOB char was reached */

yy_state_type yyFlexLexer::yy_get_previous_state()
{
	register yy_state_type yy_current_state;
	register char* yy_cp;

	yy_current_state = yy_start;

	for(yy_cp = yytext_ptr + YY_MORE_ADJ;yy_cp < yy_c_buf_p;++yy_cp)
	{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if(yy_accept[yy_current_state])
		{
			yy_last_accepting_state = yy_current_state;
			yy_last_accepting_cpos = yy_cp;
		}
		while(yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
		{
			yy_current_state = (int)yy_def[yy_current_state];
			if(yy_current_state >= 193)
				yy_c = yy_meta[(unsigned int) yy_c];
		}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	}

	return yy_current_state;
}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

yy_state_type yyFlexLexer::yy_try_NUL_trans(yy_state_type yy_current_state)
{
	register int yy_is_jam;
	register char* yy_cp = yy_c_buf_p;

	register YY_CHAR yy_c = 1;
	if(yy_accept[yy_current_state])
	{
		yy_last_accepting_state = yy_current_state;
		yy_last_accepting_cpos = yy_cp;
	}
	while(yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
	{
		yy_current_state = (int)yy_def[yy_current_state];
		if(yy_current_state >= 193)
			yy_c = yy_meta[(unsigned int) yy_c];
	}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 192);

	return yy_is_jam ? 0 : yy_current_state;
}


void yyFlexLexer::yyunput(int c, register char* yy_bp)
{
	register char* yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if(yy_cp < yy_current_buffer->yy_ch_buf + 2)
	{
		/* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char* dest = &yy_current_buffer->yy_ch_buf[yy_current_buffer->yy_buf_size + 2];
		register char* source = &yy_current_buffer->yy_ch_buf[number_to_move];

		while(source > yy_current_buffer->yy_ch_buf)
			*--dest = *--source;

		yy_cp += (int)(dest - source);
		yy_bp += (int)(dest - source);
		yy_current_buffer->yy_n_chars = yy_n_chars = yy_current_buffer->yy_buf_size;

		if(yy_cp < yy_current_buffer->yy_ch_buf + 2)
			YY_FATAL_ERROR("flex scanner push-back overflow");
	}

	*--yy_cp = (char)c;


	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
}


int yyFlexLexer::yyinput()
{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if(*yy_c_buf_p == YY_END_OF_BUFFER_CHAR)
	{
		/* yy_c_buf_p now points to the character we want to return.
						 * If this occurs *before* the EOB characters, then it's a
						 * valid NUL; if not, then we've hit the end of the buffer.
						 */
		if(yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars])
		/* This was really a NUL. */
			*yy_c_buf_p = '\0';
		else
		{
			/* need more input */
			int offset = yy_c_buf_p - yytext_ptr;
			++yy_c_buf_p;

			switch(yy_get_next_buffer())
			{
			case EOB_ACT_LAST_MATCH:
				/* This happens because yy_g_n_b()
													 * sees that we've accumulated a
													 * token and flags that we need to
													 * try matching the token before
													 * proceeding.  But for input(),
													 * there's no matching to consider.
													 * So convert the EOB_ACT_LAST_MATCH
													 * to EOB_ACT_END_OF_FILE.
													 */

				/* Reset buffer status. */
				yyrestart(yyin);

				/* fall through */

			case EOB_ACT_END_OF_FILE:
				{
					if(yywrap())
						return EOF;

					if(!yy_did_buffer_switch_on_eof)
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p = yytext_ptr + offset;
				break;
			}
		}
	}

	c = *(unsigned char*)yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;


	return c;
}


void yyFlexLexer::yyrestart(istream* input_file)
{
	if(!yy_current_buffer)
		yy_current_buffer = yy_create_buffer(yyin, YY_BUF_SIZE);

	yy_init_buffer(yy_current_buffer, input_file);
	yy_load_buffer_state();
}


void yyFlexLexer::yy_switch_to_buffer(YY_BUFFER_STATE new_buffer)
{
	if(yy_current_buffer == new_buffer)
		return;

	if(yy_current_buffer)
	{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
	}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
}


void yyFlexLexer::yy_load_buffer_state()
{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
}


YY_BUFFER_STATE yyFlexLexer::yy_create_buffer(istream* file, int size)
{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE)yy_flex_alloc(sizeof(struct yy_buffer_state));
	if(!b)
		YY_FATAL_ERROR("out of dynamic memory in yy_create_buffer()");

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char*)yy_flex_alloc(b->yy_buf_size + 2);
	if(!b->yy_ch_buf)
		YY_FATAL_ERROR("out of dynamic memory in yy_create_buffer()");

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b, file);

	return b;
}


void yyFlexLexer::yy_delete_buffer(YY_BUFFER_STATE b)
{
	if(!b)
		return;

	if(b == yy_current_buffer)
		yy_current_buffer = (YY_BUFFER_STATE)0;

	if(b->yy_is_our_buffer)
		yy_flex_free((void*)b->yy_ch_buf);

	yy_flex_free((void*)b);
}


extern "C" int isatty YY_PROTO((int));
void yyFlexLexer::yy_init_buffer(YY_BUFFER_STATE b, istream* file)
{
	yy_flush_buffer(b);

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

	b->yy_is_interactive = 0;
}


void yyFlexLexer::yy_flush_buffer(YY_BUFFER_STATE b)
{
	if(!b)
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if(b == yy_current_buffer)
		yy_load_buffer_state();
}


#ifndef YY_NO_SCAN_BUFFER
#endif


#ifndef YY_NO_SCAN_STRING
#endif


#ifndef YY_NO_SCAN_BYTES
#endif


#ifndef YY_NO_PUSH_STATE
void yyFlexLexer::yy_push_state(int new_state)
{
	if(yy_start_stack_ptr >= yy_start_stack_depth)
	{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof(int);

		if(!yy_start_stack)
			yy_start_stack = (int*)yy_flex_alloc(new_size);
		else
			yy_start_stack = (int*)yy_flex_realloc((void*)yy_start_stack, new_size);

		if(!yy_start_stack)
			YY_FATAL_ERROR("out of memory expanding start-condition stack");
	}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
}
#endif


#ifndef YY_NO_POP_STATE
void yyFlexLexer::yy_pop_state()
{
	if(--yy_start_stack_ptr < 0)
		YY_FATAL_ERROR("start-condition stack underflow");

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
}
#endif


#ifndef YY_NO_TOP_STATE
int yyFlexLexer::yy_top_state()
{
	return yy_start_stack[yy_start_stack_ptr - 1];
}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif


void yyFlexLexer::LexerError(yyconst char msg[])
{
	cerr << msg << '\n';
	exit(YY_EXIT_FAILURE);
}


/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy(char* s1, yyconst char* s2, int n)
#else
static void yy_flex_strncpy(s1, s2, n)
char*s1;
yyconst char* s2;
int n;
#endif
{
	register int i;
	for(i = 0;i < n;++i)
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen(yyconst char* s)
#else
static int yy_flex_strlen(s)
yyconst char*s;
#endif
{
	register int n;
	for(n = 0;s[n];++n)
		;

	return n;
}
#endif


#ifdef YY_USE_PROTOS
static void* yy_flex_alloc(yy_size_t size)
#else
static void *yy_flex_alloc(size)
yy_size_t size;
#endif
{
	return (void*)malloc(size);
}

#ifdef YY_USE_PROTOS
static void* yy_flex_realloc(void *ptr, yy_size_t size)
#else
static void *yy_flex_realloc(ptr, size)
void* ptr;
yy_size_t size;
#endif
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void*)realloc((char*)ptr, size);
}

#ifdef YY_USE_PROTOS
static void yy_flex_free(void* ptr)
#else
static void yy_flex_free(ptr)
void*ptr;
#endif
{
	free(ptr);
}

#if YY_MAIN
int main()
{
	yylex();
	return 0;
}
#endif
