////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#include "strfunc.h"

#define yyFlexLexer HTMLFlexLexer

/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /home/daffy/u0/vern/flex/RCS/flex.skl,v 2.91 96/09/10 16:58:48 vern Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif

#ifdef __cplusplus

#include <stdlib.h>
#include <iosfwd>
using namespace std;
//class istream;
//#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
#pragma warn -rch
#pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state* YY_BUFFER_STATE;

extern int yyleng;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;

struct yy_buffer_state
{
	istream* 	yy_input_file;

	char* 		yy_ch_buf;		/* input buffer */
	char* 		yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t	yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int			yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int			yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int			yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int			yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int			yy_fill_buffer;

	int			yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
};

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer

static void* yy_flex_alloc YY_PROTO((yy_size_t));
static void* yy_flex_realloc YY_PROTO((void *, yy_size_t));
static void yy_flex_free YY_PROTO((void*));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)

#define yywrap() 1
#define YY_SKIP_YYWRAP
typedef unsigned char YY_CHAR;
#define yytext_ptr yytext
#define YY_INTERACTIVE

#include "FlexLexer.h"

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 72
#define YY_END_OF_BUFFER 73
static yyconst short int yy_accept[344] =
{
	0, 0, 0, 51, 51, 54, 54, 61, 61, 0, 0, 63, 63, 65, 65, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 49, 0, 0, 73, 67, 67, 2, 51, 13, 12, 50, 57, 54, 54, 52, 57, 56, 53, 55, 61, 61, 62, 59, 58, 60, 72, 63, 64, 65, 66, 15, 15, 17, 16, 29, 29, 31, 32, 30, 33, 35, 36, 34, 37, 38, 39, 39, 42, 42, 43, 43, 72, 72, 45, 49, 72, 72, 48, 67, 68, 69, 69, 0, 69, 0, 0, 0, 0, 0, 0, 51, 13, 50, 57, 54, 54, 53, 52, 55, 53, 61, 61, 62, 59, 58, 63, 65, 15, 20, 19, 18, 21, 0, 31, 35, 38, 40, 0, 43, 44, 0, 0, 45, 45, 49, 0, 0, 0, 0, 48, 70, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22, 0, 0, 40, 41, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 7, 0, 26, 0, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 10, 8, 0, 0, 0, 6, 7, 1, 27, 0, 0, 0, 0, 0, 0, 11, 9, 0, 0, 0, 5, 10, 0, 6, 28, 0, 14, 0, 0, 0, 11, 0, 5, 0, 0, 4, 0, 0, 0, 0, 0, 0, 3, 4, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47, 0, 46, 47, 47, 46, 0
} ;

static yyconst int yy_ec[256] =
{
	0, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 1, 1, 5, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 6, 7, 8, 1, 1, 1, 1, 9, 1, 1, 10, 1, 1, 11, 12, 13, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 12, 15, 16, 17, 18, 19, 1, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 29, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 29, 29, 29, 29, 20, 21, 1, 1, 22, 1, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 29, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 29, 29, 29, 29, 1, 44, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
} ;

static yyconst int yy_meta[45] =
{
	0, 1, 2, 3, 4, 4, 5, 6, 7, 8, 9, 10, 6, 11, 12, 13, 14, 15, 16, 1, 17, 18, 6, 19, 19, 20, 21, 19, 19, 19, 20, 19, 19, 19, 19, 19, 19, 19, 19, 22, 19, 19, 19, 19, 23
} ;

static yyconst short int yy_base[404] =
{
	0, 0, 1, 17, 0, 61, 0, 104, 121, 0, 0, 1373, 1372, 1372, 1371, 0, 0, 127, 137, 107, 112, 1374, 1373, 111, 126, 1372, 1371, 144, 147, 1364, 1322, 141, 143, 0, 0, 162, 191, 0, 4, 1304, 0, 0, 221, 0, 0, 1273, 0, 0, 167, 172, 265, 1269, 1984, 177, 1984, 0, 196, 201, 206, 247, 1984, 1984, 0, 1984, 0, 1984, 0, 0, 1984, 1984, 1, 1268, 0, 1984, 1984, 1984, 0, 1984, 1984, 1984, 0, 1984, 1984, 1261, 1248, 0, 1236, 144, 172, 1984, 161, 1203, 1135, 0, 0, 1984, 266, 0, 254, 1984, 1136, 1136, 1133, 1122, 1101, 1068, 0, 0, 0, 0, 289, 294, 299, 311, 1984, 312, 0, 331, 336, 341, 346, 0, 0, 0, 1984, 1984, 1984, 1984, 354, 0, 0, 0, 1096, 1083, 0, 1984, 200, 201, 1984, 1984, 190, 1064, 1057, 1062, 1055, 0, 1984, 1049, 1051, 1048, 1051, 1037, 1049, 1023, 1030, 1022, 1030, 1984, 359, 1026, 1032, 1984, 1002, 1005, 1004, 1016, 999, 1006, 1003, 1007, 1008, 1005, 1006, 1001, 1984, 988, 999, 1008, 984, 986, 973, 629, 621, 621, 607, 620, 599, 596, 1984, 600, 595, 601, 600, 600, 585, 594, 577, 241, 586, 574, 242, 573, 1984, 560, 530, 532, 528, 269, 526, 500, 270, 309, 310, 1984, 502, 353, 354, 355, 1984, 518, 1984, 489, 372, 470, 366, 367, 368, 1984, 474, 369, 370, 377, 1984, 1984, 469, 378, 379, 1984, 1984, 1984, 1984, 398, 403, 402, 478, 380, 399, 1984, 1984, 461, 400, 401, 1984, 1984, 408, 1984, 1984, 425, 1984, 414, 100, 457, 1984, 419, 1984, 420, 421, 1984, 103, 231, 445, 450, 422, 423, 1984, 1984, 457, 471, 459, 476, 456, 1984, 464, 460, 462, 469, 486, 466, 502, 512, 447, 518, 444, 457, 442, 426, 420, 415, 433, 547, 415, 529, 0, 389, 386, 380, 328, 328, 298, 298, 267, 244, 523, 235, 541, 590, 557, 0, 529, 237, 573, 556, 219, 558, 248, 178, 293, 339, 578, 161, 601, 583, 105, 102, 105, 81, 606, 605, 633, 638, 649, 613, 656, 1984, 662, 685, 708, 731, 754, 777, 800, 823, 846, 869, 892, 915, 938, 961, 984, 1007, 1025, 1047, 1070, 1093, 1116, 1139, 1162, 1185, 1208, 1231, 1254, 1277, 1300, 1323, 1346, 1368, 1388, 1411, 1434, 1457, 1480, 1503, 1526, 1549, 1572, 1595, 1618, 1641, 1664, 1687, 1710, 1733, 1756, 1779, 1801, 1824, 1846, 1859, 1881, 1893, 1914, 1936, 1948, 1960
} ;

static yyconst short int yy_def[404] =
{
	0, 344, 344, 343, 3, 343, 5, 345, 345, 346, 346, 347, 347, 348, 348, 346, 346, 349, 349, 350, 350, 351, 351, 352, 352, 353, 353, 354, 354, 355, 355, 356, 356, 346, 346, 346, 346, 357, 357, 343, 358, 358, 343, 359, 360, 359, 359, 361, 361, 343, 362, 361, 343, 343, 343, 363, 363, 343, 343, 343, 343, 343, 364, 343, 365, 343, 366, 366, 343, 343, 367, 368, 369, 343, 343, 343, 370, 343, 343, 343, 371, 343, 343, 372, 368, 373, 343, 374, 374, 343, 375, 343, 343, 376, 358, 343, 377, 378, 343, 343, 343, 343, 343, 343, 343, 343, 359, 360, 359, 361, 361, 343, 343, 362, 343, 343, 363, 363, 343, 343, 343, 364, 365, 366, 343, 343, 343, 343, 379, 369, 370, 371, 372, 380, 373, 343, 374, 374, 343, 343, 375, 343, 343, 343, 343, 376, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 379, 381, 380, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 382, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 383, 343, 343, 343, 343, 343, 343, 343, 384, 343, 343, 385, 343, 343, 386, 343, 343, 343, 387, 343, 343, 388, 384, 384, 343, 343, 389, 385, 385, 343, 343, 343, 390, 343, 343, 391, 387, 387, 343, 343, 392, 388, 388, 343, 343, 343, 389, 389, 343, 343, 343, 343, 393, 343, 394, 343, 391, 391, 343, 343, 343, 392, 392, 343, 343, 395, 343, 343, 393, 343, 394, 396, 343, 343, 397, 343, 395, 395, 343, 396, 398, 343, 343, 397, 397, 343, 343, 343, 343, 343, 343, 399, 343, 343, 399, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 299, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 315, 343, 343, 343, 400, 343, 400, 401, 343, 401, 402, 343, 343, 343, 343, 343, 343, 343, 343, 343, 403, 343, 343, 343, 403, 343, 0, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343
} ;

static yyconst short int yy_nxt[2029] =
{
	0, 343, 343, 343, 41, 41, 61, 343, 61, 61, 61, 125, 61, 61, 126, 343, 42, 42, 43, 43, 43, 43, 43, 43, 44, 43, 43, 43, 44, 44, 45, 44, 43, 43, 43, 46, 43, 43, 43, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 44, 43, 47, 48, 49, 49, 49, 49, 50, 47, 47, 47, 50, 50, 51, 50, 47, 52, 53, 54, 47, 47, 47, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 47, 56, 57, 57, 57, 57, 337, 58, 59, 269, 270, 73, 269, 270, 77, 60, 73, 61, 56, 57, 57, 57, 57, 74, 58, 59, 67, 78, 74, 77, 68, 69, 60, 336, 61, 70, 67, 335, 71, 334, 68, 69, 78, 81, 82, 70, 81, 82, 71, 88, 83, 88, 137, 83, 89, 84, 89, 138, 84, 90, 90, 90, 90, 90, 110, 111, 111, 111, 111, 111, 111, 111, 111, 111, 115, 115, 115, 115, 115, 112, 137, 141, 91, 333, 112, 139, 142, 92, 90, 90, 90, 90, 90, 117, 118, 118, 118, 118, 118, 118, 118, 118, 118, 119, 119, 119, 119, 119, 137, 137, 141, 91, 329, 138, 139, 142, 92, 95, 96, 96, 96, 96, 96, 97, 95, 95, 95, 95, 95, 98, 95, 95, 95, 95, 95, 99, 95, 95, 95, 100, 269, 270, 325, 101, 120, 120, 120, 120, 120, 212, 217, 102, 103, 104, 213, 218, 105, 327, 328, 322, 95, 109, 109, 96, 96, 96, 96, 96, 109, 109, 109, 316, 147, 109, 313, 109, 148, 226, 231, 109, 109, 109, 227, 232, 149, 150, 110, 111, 111, 111, 111, 111, 111, 111, 111, 111, 115, 115, 115, 115, 115, 112, 327, 328, 109, 312, 112, 109, 109, 115, 115, 115, 115, 115, 109, 109, 109, 212, 212, 109, 311, 109, 213, 233, 310, 109, 109, 109, 117, 118, 118, 118, 118, 118, 118, 118, 118, 118, 119, 119, 119, 119, 119, 120, 120, 120, 120, 120, 327, 328, 109, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 236, 217, 217, 309, 308, 237, 218, 238, 242, 242, 242, 242, 242, 246, 226, 226, 251, 231, 247, 227, 248, 252, 232, 243, 231, 236, 236, 246, 159, 253, 237, 255, 247, 159, 257, 257, 257, 257, 257, 242, 242, 242, 242, 242, 260, 260, 246, 251, 251, 307, 258, 262, 252, 264, 243, 266, 260, 260, 306, 305, 267, 257, 257, 257, 257, 257, 273, 266, 266, 273, 273, 274, 267, 275, 274, 281, 304, 258, 300, 299, 260, 277, 277, 277, 277, 277, 279, 279, 279, 279, 279, 298, 260, 276, 276, 276, 276, 276, 284, 284, 297, 280, 284, 284, 284, 284, 270, 277, 277, 277, 277, 277, 279, 279, 279, 279, 279, 296, 295, 294, 293, 278, 288, 288, 288, 288, 288, 280, 290, 285, 287, 286, 282, 285, 271, 285, 263, 289, 288, 288, 288, 288, 288, 261, 254, 249, 244, 278, 291, 291, 291, 291, 291, 289, 291, 291, 291, 291, 291, 314, 314, 314, 314, 314, 241, 301, 301, 301, 301, 301, 239, 318, 318, 234, 315, 229, 292, 314, 314, 314, 314, 314, 292, 301, 301, 301, 301, 301, 303, 302, 302, 228, 315, 320, 320, 320, 320, 320, 324, 324, 324, 324, 319, 224, 223, 222, 303, 318, 321, 320, 320, 320, 320, 320, 331, 331, 331, 331, 331, 331, 331, 331, 331, 331, 321, 302, 317, 317, 317, 317, 317, 221, 318, 318, 324, 219, 324, 330, 330, 330, 330, 330, 338, 338, 338, 338, 338, 341, 341, 215, 328, 214, 210, 209, 332, 341, 341, 339, 208, 332, 207, 206, 205, 319, 204, 203, 201, 200, 318, 338, 338, 338, 338, 338, 342, 342, 342, 342, 342, 199, 198, 197, 196, 341, 339, 340, 340, 340, 340, 340, 195, 341, 342, 342, 342, 342, 342, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 40, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 55, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 61, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 62, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 66, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 72, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 75, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 76, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 79, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 80, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 93, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 94, 194, 94, 94, 94, 94, 94, 94, 94, 94, 94, 106, 106, 106, 106, 106, 193, 106, 106, 106, 192, 106, 191, 106, 106, 106, 106, 106, 106, 190, 189, 187, 186, 106, 107, 185, 184, 183, 107, 182, 107, 181, 180, 179, 178, 177, 176, 107, 107, 107, 107, 109, 109, 343, 175, 173, 109, 109, 109, 109, 109, 109, 109, 109, 172, 171, 170, 109, 109, 109, 109, 109, 109, 109, 113, 113, 169, 168, 167, 113, 113, 113, 113, 113, 113, 113, 113, 166, 165, 164, 113, 113, 113, 113, 113, 113, 113, 116, 116, 163, 162, 144, 116, 143, 161, 116, 116, 116, 116, 116, 343, 116, 156, 116, 116, 116, 116, 116, 116, 116, 121, 121, 121, 121, 121, 121, 121, 155, 121, 121, 121, 121, 121, 121, 121, 121, 121, 121, 121, 121, 121, 121, 121, 122, 122, 122, 122, 122, 122, 154, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 122, 123, 123, 123, 123, 123, 123, 153, 152, 123, 123, 151, 123, 123, 144, 123, 123, 123, 123, 123, 123, 123, 123, 123, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 129, 129, 129, 129, 129, 129, 129, 143, 129, 129, 129, 129, 129, 129, 129, 129, 129, 135, 129, 129, 129, 129, 129, 130, 130, 130, 130, 130, 130, 128, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 133, 130, 130, 130, 130, 130, 131, 131, 131, 128, 131, 131, 131, 131, 131, 114, 131, 131, 131, 108, 131, 131, 131, 131, 131, 131, 131, 131, 131, 132, 132, 132, 343, 132, 132, 132, 132, 132, 132, 132, 132, 132, 132, 132, 132, 132, 132, 132, 132, 132, 132, 132, 134, 134, 134, 134, 134, 134, 134, 134, 86, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 136, 140, 140, 140, 140, 86, 61, 61, 61, 61, 65, 65, 63, 63, 343, 343, 343, 343, 343, 140, 145, 145, 145, 145, 343, 145, 343, 343, 145, 145, 145, 145, 145, 145, 145, 145, 145, 145, 145, 145, 145, 145, 145, 99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 343, 99, 99, 99, 99, 99, 99, 99, 343, 343, 343, 343, 99, 146, 146, 146, 146, 343, 146, 146, 146, 146, 343, 146, 146, 146, 146, 146, 146, 343, 146, 146, 146, 343, 146, 146, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 157, 160, 160, 160, 343, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 174, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 188, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 216, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 225, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 230, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 259, 259, 259, 259, 343, 259, 259, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 259, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 265, 268, 268, 268, 268, 343, 343, 343, 343, 343, 343, 268, 268, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 272, 276, 276, 276, 276, 343, 343, 343, 343, 343, 343, 276, 276, 283, 283, 283, 283, 343, 283, 283, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 283, 323, 323, 323, 323, 343, 323, 323, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 323, 326, 326, 326, 326, 343, 343, 343, 343, 343, 343, 326, 326, 330, 330, 330, 330, 343, 343, 343, 343, 343, 343, 330, 330, 340, 340, 340, 340, 343, 340, 340, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 340, 39, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343
} ;

static yyconst short int yy_chk[2029] =
{
	0, 0, 0, 0, 1, 2, 37, 0, 37, 37, 38, 70, 38, 38, 70, 0, 1, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 7, 7, 7, 7, 7, 335, 7, 7, 260, 260, 19, 268, 268, 23, 7, 20, 7, 8, 8, 8, 8, 8, 19, 8, 8, 17, 23, 20, 24, 17, 17, 8, 334, 8, 17, 18, 333, 17, 332, 18, 18, 24, 27, 27, 18, 28, 28, 18, 31, 27, 32, 87, 28, 31, 27, 32, 87, 28, 35, 35, 35, 35, 35, 48, 48, 48, 48, 48, 49, 49, 49, 49, 49, 53, 53, 53, 53, 53, 48, 88, 90, 35, 329, 49, 88, 90, 35, 36, 36, 36, 36, 36, 56, 56, 56, 56, 56, 57, 57, 57, 57, 57, 58, 58, 58, 58, 58, 136, 137, 140, 36, 325, 136, 137, 140, 36, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 42, 269, 269, 322, 42, 59, 59, 59, 59, 59, 197, 200, 42, 42, 42, 197, 200, 42, 324, 324, 319, 42, 50, 50, 96, 96, 96, 96, 96, 50, 50, 50, 313, 98, 50, 311, 50, 98, 207, 210, 50, 50, 50, 207, 210, 98, 98, 110, 110, 110, 110, 110, 111, 111, 111, 111, 111, 112, 112, 112, 112, 112, 110, 326, 326, 50, 310, 111, 113, 113, 115, 115, 115, 115, 115, 113, 113, 113, 211, 212, 113, 309, 113, 211, 212, 308, 113, 113, 113, 117, 117, 117, 117, 117, 118, 118, 118, 118, 118, 119, 119, 119, 119, 119, 120, 120, 120, 120, 120, 327, 327, 113, 128, 128, 128, 128, 128, 158, 158, 158, 158, 158, 215, 216, 217, 307, 306, 215, 216, 217, 222, 222, 222, 222, 222, 224, 225, 226, 229, 230, 224, 225, 226, 229, 230, 222, 231, 235, 236, 245, 128, 231, 235, 236, 245, 158, 241, 241, 241, 241, 241, 242, 242, 242, 242, 242, 243, 243, 246, 250, 251, 305, 241, 246, 250, 251, 242, 254, 259, 259, 304, 303, 254, 257, 257, 257, 257, 257, 263, 265, 266, 272, 273, 263, 265, 266, 272, 273, 300, 257, 298, 297, 243, 270, 270, 270, 270, 270, 271, 271, 271, 271, 271, 296, 259, 276, 276, 276, 276, 276, 280, 280, 295, 271, 283, 283, 284, 284, 276, 277, 277, 277, 277, 277, 279, 279, 279, 279, 279, 294, 293, 292, 290, 270, 286, 286, 286, 286, 286, 279, 287, 280, 285, 282, 278, 283, 261, 284, 249, 286, 288, 288, 288, 288, 288, 244, 234, 228, 223, 277, 289, 289, 289, 289, 289, 288, 291, 291, 291, 291, 291, 312, 312, 312, 312, 312, 221, 301, 301, 301, 301, 301, 219, 318, 318, 214, 312, 209, 289, 314, 314, 314, 314, 314, 291, 299, 299, 299, 299, 299, 301, 299, 299, 208, 314, 316, 316, 316, 316, 316, 321, 321, 323, 323, 318, 206, 205, 204, 299, 318, 316, 320, 320, 320, 320, 320, 328, 328, 328, 328, 328, 331, 331, 331, 331, 331, 320, 299, 315, 315, 315, 315, 315, 203, 315, 315, 321, 201, 323, 330, 330, 330, 330, 330, 336, 336, 336, 336, 336, 337, 337, 199, 330, 198, 196, 195, 328, 341, 341, 336, 194, 331, 193, 192, 191, 315, 190, 189, 187, 186, 315, 338, 338, 338, 338, 338, 339, 339, 339, 339, 339, 185, 184, 183, 182, 337, 338, 340, 340, 340, 340, 340, 181, 341, 342, 342, 342, 342, 342, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 344, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 345, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 347, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 349, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 356, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 358, 358, 358, 358, 358, 358, 358, 358, 358, 358, 358, 358, 358, 180, 358, 358, 358, 358, 358, 358, 358, 358, 358, 359, 359, 359, 359, 359, 179, 359, 359, 359, 178, 359, 177, 359, 359, 359, 359, 359, 359, 176, 175, 173, 172, 359, 360, 171, 170, 169, 360, 168, 360, 167, 166, 165, 164, 163, 162, 360, 360, 360, 360, 361, 361, 160, 159, 156, 361, 361, 361, 361, 361, 361, 361, 361, 155, 154, 153, 361, 361, 361, 361, 361, 361, 361, 362, 362, 152, 151, 150, 362, 362, 362, 362, 362, 362, 362, 362, 149, 148, 147, 362, 362, 362, 362, 362, 362, 362, 363, 363, 144, 143, 142, 363, 141, 133, 363, 363, 363, 363, 363, 132, 363, 105, 363, 363, 363, 363, 363, 363, 363, 364, 364, 364, 364, 364, 364, 364, 104, 364, 364, 364, 364, 364, 364, 364, 364, 364, 364, 364, 364, 364, 364, 364, 365, 365, 365, 365, 365, 365, 103, 365, 365, 365, 365, 365, 365, 365, 365, 365, 365, 365, 365, 365, 365, 365, 365, 366, 366, 366, 366, 366, 366, 102, 101, 366, 366, 100, 366, 366, 92, 366, 366, 366, 366, 366, 366, 366, 366, 366, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 369, 369, 369, 369, 369, 369, 369, 91, 369, 369, 369, 369, 369, 369, 369, 369, 369, 86, 369, 369, 369, 369, 369, 370, 370, 370, 370, 370, 370, 84, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 83, 370, 370, 370, 370, 370, 371, 371, 371, 71, 371, 371, 371, 371, 371, 51, 371, 371, 371, 45, 371, 371, 371, 371, 371, 371, 371, 371, 371, 372, 372, 372, 39, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 373, 373, 373, 373, 373, 373, 373, 373, 30, 373, 373, 373, 373, 373, 373, 373, 373, 373, 373, 373, 373, 373, 373, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 374, 375, 375, 375, 375, 29, 26, 25, 22, 21, 14, 13, 12, 11, 0, 0, 0, 0, 0, 375, 376, 376, 376, 376, 0, 376, 0, 0, 376, 376, 376, 376, 376, 376, 376, 376, 376, 376, 376, 376, 376, 376, 376, 377, 377, 377, 377, 377, 377, 377, 377, 377, 377, 0, 377, 377, 377, 377, 377, 377, 377, 0, 0, 0, 0, 377, 378, 378, 378, 378, 0, 378, 378, 378, 378, 0, 378, 378, 378, 378, 378, 378, 0, 378, 378, 378, 0, 378, 378, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 379, 380, 380, 380, 0, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 380, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 381, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 382, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 383, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 384, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 385, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 386, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 387, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 389, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 392, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 393, 394, 394, 394, 394, 0, 394, 394, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 394, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 395, 396, 396, 396, 396, 0, 0, 0, 0, 0, 0, 396, 396, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 397, 398, 398, 398, 398, 0, 0, 0, 0, 0, 0, 398, 398, 399, 399, 399, 399, 0, 399, 399, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 399, 400, 400, 400, 400, 0, 400, 400, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 400, 401, 401, 401, 401, 0, 0, 0, 0, 0, 0, 401, 401, 402, 402, 402, 402, 0, 0, 0, 0, 0, 0, 402, 402, 403, 403, 403, 403, 0, 403, 403, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 403, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343, 343
} ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
#define INITIAL 0
#include "tokensDefs.h"
#define ST_TAG 1

#define ST_TAG_PARAMETER 2

#define ST_TAG_PARAMETER_VALUE 3

#define ST_COMMENT 4

#define ST_VALUE_ONE_QUOTED 5

#define ST_VALUE_DOUBLE_QUOTED 6

#define ST_EOF 7

#define S_SCRIPT 8

#define S_SCRIPT_APOS 9

#define S_SCRIPT_APOS_ESC 10

#define S_SCRIPT_STRING 11

#define S_SCRIPT_STRING_ESC 12

#define S_SCRIPT_COMMENT 13

#define S_SCRIPT_MCOMMENT 14

#define S_STYLE 15

#define S_IN_STYLE 16

#define S_META_TAG 17

#define S_META_REFRESH_URL 18

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO((void));
#else
extern int yywrap YY_PROTO((void));
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO((char *, yyconst char *, int));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO((yyconst char*));
#endif

#ifndef YY_NO_INPUT
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int* yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO((int new_state));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO((void));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO((void));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
#define ECHO LexerOutput( yytext, yyleng )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( (result = LexerInput( (char *) buf, max_size )) < 0 ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) LexerError( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yyFlexLexer::yylex()
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

YY_DECL
{
	register yy_state_type yy_current_state;
	register char* yy_cp, * yy_bp;
	register int yy_act;

	if(yy_init)
	{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if(!yy_start)
			yy_start = 1;	/* first start state */

		if(!yyin)
			yyin = &cin;

		if(!yyout)
			yyout = &cout;

		if(!yy_current_buffer)
			yy_current_buffer = yy_create_buffer(yyin, YY_BUF_SIZE);

		yy_load_buffer_state();
	}

	while(1)		/* loops until end-of-file is reached */
	{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
																				 * the current run.
																				 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
		yy_match:
		do
		{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if(yy_accept[yy_current_state])
			{
				yy_last_accepting_state = yy_current_state;
				yy_last_accepting_cpos = yy_cp;
			}
			while(yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
			{
				yy_current_state = (int)yy_def[yy_current_state];
				if(yy_current_state >= 344)
					yy_c = yy_meta[(unsigned int) yy_c];
			}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
		}
		while(yy_base[yy_current_state] != 1984);

		yy_find_action : yy_act = yy_accept[yy_current_state];
		if(yy_act == 0)
		{
			/* have to back up */
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			yy_act = yy_accept[yy_current_state];
		}

		YY_DO_BEFORE_ACTION;

		do_action:	/* This label is used only to access EOF actions. */

		switch(yy_act)
		{
			/* beginning of action switch */
		case 0:
			/* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = yy_hold_char;
			yy_cp = yy_last_accepting_cpos;
			yy_current_state = yy_last_accepting_state;
			goto yy_find_action;

		case 1:
			YY_RULE_SETUP
			{
				return T_EOF;
			}
			YY_BREAK
		case YY_STATE_EOF(INITIAL):
		case YY_STATE_EOF(ST_TAG):
		case YY_STATE_EOF(ST_TAG_PARAMETER):
		case YY_STATE_EOF(ST_TAG_PARAMETER_VALUE):
		case YY_STATE_EOF(ST_COMMENT):
		case YY_STATE_EOF(ST_VALUE_ONE_QUOTED):
		case YY_STATE_EOF(ST_VALUE_DOUBLE_QUOTED):
		case YY_STATE_EOF(ST_EOF):
		case YY_STATE_EOF(S_SCRIPT):
		case YY_STATE_EOF(S_SCRIPT_APOS):
		case YY_STATE_EOF(S_SCRIPT_APOS_ESC):
		case YY_STATE_EOF(S_SCRIPT_STRING):
		case YY_STATE_EOF(S_SCRIPT_STRING_ESC):
		case YY_STATE_EOF(S_SCRIPT_COMMENT):
		case YY_STATE_EOF(S_SCRIPT_MCOMMENT):
		case YY_STATE_EOF(S_STYLE):
		case YY_STATE_EOF(S_IN_STYLE):
		case YY_STATE_EOF(S_META_TAG):
		case YY_STATE_EOF(S_META_REFRESH_URL):
			{
				return T_EOF;
			}
			YY_BREAK
		case 2:
			YY_RULE_SETUP
			{
				BEGIN(ST_TAG); return T_BEGIN_TAG;
			}
			YY_BREAK
			/***********************NOSCRIPT ************************/
		case 3:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_NOSCRIPT_END;
			}
			YY_BREAK
		case 4:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_NOSCRIPT;
			}
			YY_BREAK
			/***********************END NOSCRIPT ************************/
			/***********************OBJECTS ************************/
		case 5:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_OBJECT;
			}
			YY_BREAK
		case 6:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_OBJECT;
			}
			YY_BREAK
		case 7:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_OBJECT;
			}
			YY_BREAK
		case 8:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_OBJECT;
			}
			YY_BREAK
		case 9:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_OBJECT;
			}
			YY_BREAK
		case 10:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_OBJECT;
			}
			YY_BREAK
		case 11:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_OBJECT;
			}
			YY_BREAK
			/***********************END OBJECTS ************************/

			/*
			<INITIAL>{COMMENT_BEGIN}	{BEGIN(ST_COMMENT);return T_BEGIN_COMMENT;}
			*/

		case 12:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_CLOSE_TAG;
			}
			YY_BREAK
		case 13:
			YY_RULE_SETUP
			{
				if(stricmp(yytext, "script") == 0)
				{
					BEGIN(S_SCRIPT);return(T_SCRIPT);
				}
				else if(stricmp(yytext, "style") == 0)
				{
					BEGIN(S_STYLE); return(T_TAG_NAME);
				}
				else if(stricmp(yytext, "meta") == 0)
				{
					BEGIN(S_META_TAG); return(T_TAG_NAME);
				}
				else
				{
					BEGIN(ST_TAG_PARAMETER);return T_TAG_NAME;
				}
			}
			YY_BREAK
			/*********************** SCRIPT ************************/
		case 14:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 15:
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 16:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT_APOS);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 17:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT_STRING);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 18:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT_COMMENT);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 19:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT_MCOMMENT);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 20:
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 21:
			*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
			yy_c_buf_p = yy_cp = yy_bp + 1;
			YY_DO_BEFORE_ACTION; /* set up yytext again */
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 22:
			*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
			yy_c_buf_p = yy_cp -= 1;
			YY_DO_BEFORE_ACTION; /* set up yytext again */
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 23:
			*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
			yy_c_buf_p = yy_cp -= 1;
			YY_DO_BEFORE_ACTION; /* set up yytext again */
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 24:
			*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
			yy_c_buf_p = yy_cp -= 1;
			YY_DO_BEFORE_ACTION; /* set up yytext again */
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 25:
			*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
			yy_c_buf_p = yy_cp -= 1;
			YY_DO_BEFORE_ACTION; /* set up yytext again */
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 26:
			*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
			yy_c_buf_p = yy_cp -= 1;
			YY_DO_BEFORE_ACTION; /* set up yytext again */
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 27:
			*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
			yy_c_buf_p = yy_cp -= 1;
			YY_DO_BEFORE_ACTION; /* set up yytext again */
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 28:
			*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
			yy_c_buf_p = yy_cp -= 1;
			YY_DO_BEFORE_ACTION; /* set up yytext again */
			YY_RULE_SETUP
			{
				BEGIN(INITIAL);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 29:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 30:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT_APOS_ESC);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 31:
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 32:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 33:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT_APOS);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 34:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT_STRING_ESC);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 35:
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 36:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 37:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT_STRING);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 38:
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 39:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 40:
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 41:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 42:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT);
				return(T_SCRIPT);
			}
			YY_BREAK
		case 43:
			YY_RULE_SETUP
			{
				return(T_SCRIPT);
			}
			YY_BREAK
		case 44:
			YY_RULE_SETUP
			{
				BEGIN(S_SCRIPT);
				return(T_SCRIPT);
			}
			YY_BREAK
			/***********************END SCRIPT ************************/
			/***********************HTML STYLE ************************/
		case 45:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_IN_STYLE;
			}
			YY_BREAK
			/***********************END HTML STYLE ************************/
			/***********************META REFRESH ************************/
		case 46:
			YY_RULE_SETUP
			{
				BEGIN(S_META_REFRESH_URL); return T_TAG_ADDITIONS;
			}
			YY_BREAK
		case 47:
			YY_RULE_SETUP
			{
				BEGIN(S_META_REFRESH_URL); return T_TAG_ADDITIONS;
			}
			YY_BREAK
		case 48:
			YY_RULE_SETUP
			{
				BEGIN(ST_TAG_PARAMETER); return T_META_REFRESH_URL;
			}
			YY_BREAK
		case 49:
			YY_RULE_SETUP
			{
				BEGIN(ST_TAG_PARAMETER); return T_TAG_ADDITIONS;
			}
			YY_BREAK
			/***********************END META REFRESH ************************/
			/***********************MAIN HTML ************************/
		case 50:
			YY_RULE_SETUP
			{
				return T_ERROR;
			}
			YY_BREAK
		case 51:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL);return T_ERROR;
			}
			YY_BREAK

			/*
			<ST_COMMENT>{COMMENT_END}	{BEGIN(INITIAL);return T_END_COMMENT;}

			<ST_COMMENT>{COMMENT_TEXT}*	{return T_TAG_ADDITIONS;}

			<ST_COMMENT>">"	{return T_TAG_ADDITIONS;}

			<ST_COMMENT>"-"	{return T_TAG_ADDITIONS;}
			*/

		case 52:
			YY_RULE_SETUP
			{
				return T_TAG_PARAMETER;
			}
			YY_BREAK
		case 53:
			YY_RULE_SETUP
			{
				BEGIN(ST_TAG_PARAMETER_VALUE);return T_NOTHING;
			}
			YY_BREAK
		case 54:
			YY_RULE_SETUP
			{
				return T_TAG_ADDITIONS;
			}
			YY_BREAK
		case 55:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL); return T_END_TAG;
			}
			YY_BREAK
		case 56:
			YY_RULE_SETUP
			{
				BEGIN(ST_TAG);return T_BEGIN_TAG;
			}
			YY_BREAK
		case 57:
			YY_RULE_SETUP
			{
				return T_TAG_ADDITIONS;
			}
			YY_BREAK
		case 58:
			YY_RULE_SETUP
			{
				BEGIN(ST_VALUE_ONE_QUOTED);return T_QUOT;
			}
			YY_BREAK
		case 59:
			YY_RULE_SETUP
			{
				BEGIN(ST_VALUE_DOUBLE_QUOTED);return T_DOUBLEQUOT;
			}
			YY_BREAK
		case 60:
			YY_RULE_SETUP
			{
				BEGIN(ST_TAG);return T_BEGIN_TAG;
			}
			YY_BREAK
		case 61:
			YY_RULE_SETUP
			{
				BEGIN(ST_TAG_PARAMETER);return T_TAG_PARAMETER_VALUE;
			}
			YY_BREAK
		case 62:
			YY_RULE_SETUP
			{
				BEGIN(ST_TAG_PARAMETER);return T_NOTHING;
			}
			YY_BREAK
		case 63:
			YY_RULE_SETUP
			{
				BEGIN(ST_VALUE_ONE_QUOTED);return T_TAG_PARAMETER_VALUE;
			}
			YY_BREAK
		case 64:
			YY_RULE_SETUP
			{
				BEGIN(ST_TAG_PARAMETER);return T_TAG_PARAMETER_VALUE_EMPTY;
			}
			YY_BREAK
		case 65:
			YY_RULE_SETUP
			{
				BEGIN(ST_VALUE_DOUBLE_QUOTED);return T_TAG_PARAMETER_VALUE;
			}
			YY_BREAK
		case 66:
			YY_RULE_SETUP
			{
				BEGIN(ST_TAG_PARAMETER);return T_TAG_PARAMETER_VALUE_EMPTY;
			}
			YY_BREAK
		case 67:
			YY_RULE_SETUP
			{
				return T_TEXT;
			}
			YY_BREAK
		case 68:
			YY_RULE_SETUP
			{
				return T_TEXT;
			}
			YY_BREAK
		case 69:
			YY_RULE_SETUP
			{
				return T_TEXT;
			}
			YY_BREAK
		case 70:
			YY_RULE_SETUP
			{
				return T_TEXT;
			}
			YY_BREAK
		case 71:
			YY_RULE_SETUP
			{
				BEGIN(INITIAL);
			}
			YY_BREAK
		case 72:
			YY_RULE_SETUP ECHO;
			YY_BREAK

		case YY_END_OF_BUFFER:
			{
				/* Amount of text matched not including the EOB char. */
				int yy_amount_of_matched_text = (int)(yy_cp - yytext_ptr) - 1;

				/* Undo the effects of YY_DO_BEFORE_ACTION. */
				*yy_cp = yy_hold_char;
				YY_RESTORE_YY_MORE_OFFSET

				if(yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW)
				{
					/* We're scanning a new file or input source.  It's
																																																										 * possible that this happened because the user
																																																										 * just pointed yyin at a new source and called
																																																										 * yylex().  If so, then we have to assure
																																																										 * consistency between yy_current_buffer and our
																																																										 * globals.  Here is the right place to do so, because
																																																										 * this is the first action (other than possibly a
																																																										 * back-up) that will match for the new input source.
																																																										 */
					yy_n_chars = yy_current_buffer->yy_n_chars;
					yy_current_buffer->yy_input_file = yyin;
					yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
				}

				/* Note that here we test for yy_c_buf_p "<=" to the position
																																							 * of the first EOB in the buffer, since yy_c_buf_p will
																																							 * already have been incremented past the NUL character
																																							 * (since all states make transitions on EOB to the
																																							 * end-of-buffer state).  Contrast this with the test
																																							 * in input().
																																							 */
				if(yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars])
				{
					/* This was really a NUL. */
					yy_state_type yy_next_state;

					yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

					yy_current_state = yy_get_previous_state();

					/* Okay, we're now positioned to make the NUL
																																																							 * transition.  We couldn't have
																																																							 * yy_get_previous_state() go ahead and do it
																																																							 * for us because it doesn't know how to deal
																																																							 * with the possibility of jamming (and we don't
																																																							 * want to build jamming into it because then it
																																																							 * will run more slowly).
																																																							 */

					yy_next_state = yy_try_NUL_trans(yy_current_state);

					yy_bp = yytext_ptr + YY_MORE_ADJ;

					if(yy_next_state)
					{
						/* Consume the NUL. */
						yy_cp = ++yy_c_buf_p;
						yy_current_state = yy_next_state;
						goto yy_match;
					}
					else
					{
						yy_cp = yy_c_buf_p;
						goto yy_find_action;
					}
				}
				else
					switch(yy_get_next_buffer())
					{
					case EOB_ACT_END_OF_FILE:
						{
							yy_did_buffer_switch_on_eof = 0;

							if(yywrap())
							{
								/* Note: because we've taken care in
																																																																																																 * yy_get_next_buffer() to have set up
																																																																																																 * yytext, we can now set up
																																																																																																 * yy_c_buf_p so that if some total
																																																																																																 * hoser (like flex itself) wants to
																																																																																																 * call the scanner after we return the
																																																																																																 * YY_NULL, it'll still work - another
																																																																																																 * YY_NULL will get returned.
																																																																																																 */
								yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

								yy_act = YY_STATE_EOF(YY_START);
								goto do_action;
							}
							else
							{
								if(!yy_did_buffer_switch_on_eof)
									YY_NEW_FILE;
							}
							break;
						}

					case EOB_ACT_CONTINUE_SCAN:
						yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

						yy_current_state = yy_get_previous_state();

						yy_cp = yy_c_buf_p;
						yy_bp = yytext_ptr + YY_MORE_ADJ;
						goto yy_match;

					case EOB_ACT_LAST_MATCH:
						yy_c_buf_p = &yy_current_buffer->yy_ch_buf[yy_n_chars];

						yy_current_state = yy_get_previous_state();

						yy_cp = yy_c_buf_p;
						yy_bp = yytext_ptr + YY_MORE_ADJ;
						goto yy_find_action;
					}
				break;
			}

		default:
			YY_FATAL_ERROR("fatal flex scanner internal error--no action found");
		} /* end of action switch */
	} /* end of scanning one token */
} /* end of yylex */

yyFlexLexer::yyFlexLexer(istream* arg_yyin, ostream* arg_yyout)
{
	yyin = arg_yyin;
	yyout = arg_yyout;
	yy_c_buf_p = 0;
	yy_init = 1;
	yy_start = 0;
	yy_flex_debug = 0;
	yylineno = 1;	// this will only get updated if %option yylineno

	yy_did_buffer_switch_on_eof = 0;

	yy_looking_for_trail_begin = 0;
	yy_more_flag = 0;
	yy_more_len = 0;
	yy_more_offset = yy_prev_more_offset = 0;

	yy_start_stack_ptr = yy_start_stack_depth = 0;
	yy_start_stack = 0;

	yy_current_buffer = 0;

#ifdef YY_USES_REJECT
	yy_state_buf = new yy_state_type[YY_BUF_SIZE + 2];
#else
	yy_state_buf = 0;
#endif
}

yyFlexLexer::~yyFlexLexer()
{
	delete yy_state_buf;
	yy_delete_buffer(yy_current_buffer);
}

void yyFlexLexer::switch_streams(istream* new_in, ostream* new_out)
{
	if(new_in)
	{
		yy_delete_buffer(yy_current_buffer);
		yy_switch_to_buffer(yy_create_buffer(new_in, YY_BUF_SIZE));
	}

	if(new_out)
		yyout = new_out;
}

#ifdef YY_INTERACTIVE
int yyFlexLexer::LexerInput(char* buf, int /* max_size */)
#else
int yyFlexLexer::LexerInput( char* buf, int max_size )
#endif
{
	if(yyin->eof() || yyin->fail())
		return 0;

#ifdef YY_INTERACTIVE
	yyin->get(buf[0]);

	if(yyin->eof())
		return 0;

	if(yyin->bad())
		return -1;

	return 1;

#else
	(void)yyin->read(buf, max_size);

	if(yyin->bad())
		return -1;
	else
		return yyin->gcount();
#endif
}

void yyFlexLexer::LexerOutput(const char* buf, int size)
{
	(void)yyout->write(buf, size);
}

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

int yyFlexLexer::yy_get_next_buffer()
{
	register char* dest = yy_current_buffer->yy_ch_buf;
	register char* source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if(yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1])
		YY_FATAL_ERROR("fatal flex scanner internal error--end of buffer missed");

	if(yy_current_buffer->yy_fill_buffer == 0)
	{
		/* Don't try to fill the buffer, so this is an EOF. */
		if(yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1)
		{
			/* We matched a single character, the EOB, so
																															 * treat this as a final EOF.
																															 */
			return EOB_ACT_END_OF_FILE;
		}
		else
		{
			/* We matched some text prior to the EOB, first
																											 * process it.
																											 */
			return EOB_ACT_LAST_MATCH;
		}
	}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int)(yy_c_buf_p - yytext_ptr) - 1;

	for(i = 0;i < number_to_move;++i)
		*(dest++) = *(source++);

	if(yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING)
	/* don't do the read, it's not guaranteed to return an EOF,
	* just force an EOF
	*/
		yy_current_buffer->yy_n_chars = yy_n_chars = 0;
	else
	{
		int num_to_read = yy_current_buffer->yy_buf_size - number_to_move - 1;

		while(num_to_read <= 0)
		{
			/* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR("input buffer overflow, can't enlarge buffer because scanner uses REJECT");
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset = (int)(yy_c_buf_p - b->yy_ch_buf);

			if(b->yy_is_our_buffer)
			{
				int new_size = b->yy_buf_size * 2;

				if(new_size <= 0)
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char*)
				/* Include room in for 2 EOB chars. */
				yy_flex_realloc((void*)b->yy_ch_buf, b->yy_buf_size + 2);
			}
			else
			/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if(!b->yy_ch_buf)
				YY_FATAL_ERROR("fatal error - scanner input buffer overflow");

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size - number_to_move - 1;
#endif
		}

		if(num_to_read > YY_READ_BUF_SIZE)
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT((&yy_current_buffer->yy_ch_buf[number_to_move]), yy_n_chars, num_to_read);

		yy_current_buffer->yy_n_chars = yy_n_chars;
	}

	if(yy_n_chars == 0)
	{
		if(number_to_move == YY_MORE_ADJ)
		{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin);
		}
		else
		{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_EOF_PENDING;
		}
	}
	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

yy_state_type yyFlexLexer::yy_get_previous_state()
{
	register yy_state_type yy_current_state;
	register char* yy_cp;

	yy_current_state = yy_start;

	for(yy_cp = yytext_ptr + YY_MORE_ADJ;yy_cp < yy_c_buf_p;++yy_cp)
	{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if(yy_accept[yy_current_state])
		{
			yy_last_accepting_state = yy_current_state;
			yy_last_accepting_cpos = yy_cp;
		}
		while(yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
		{
			yy_current_state = (int)yy_def[yy_current_state];
			if(yy_current_state >= 344)
				yy_c = yy_meta[(unsigned int) yy_c];
		}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

yy_state_type yyFlexLexer::yy_try_NUL_trans(yy_state_type yy_current_state)
{
	register int yy_is_jam;
	register char* yy_cp = yy_c_buf_p;

	register YY_CHAR yy_c = 1;
	if(yy_accept[yy_current_state])
	{
		yy_last_accepting_state = yy_current_state;
		yy_last_accepting_cpos = yy_cp;
	}
	while(yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state)
	{
		yy_current_state = (int)yy_def[yy_current_state];
		if(yy_current_state >= 344)
			yy_c = yy_meta[(unsigned int) yy_c];
	}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 343);

	return yy_is_jam ? 0 : yy_current_state;
}

void yyFlexLexer::yyunput(int c, register char* yy_bp)
{
	register char* yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if(yy_cp < yy_current_buffer->yy_ch_buf + 2)
	{
		/* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char* dest = &yy_current_buffer->yy_ch_buf[yy_current_buffer->yy_buf_size + 2];
		register char* source = &yy_current_buffer->yy_ch_buf[number_to_move];

		while(source > yy_current_buffer->yy_ch_buf)
			*--dest = *--source;

		yy_cp += (int)(dest - source);
		yy_bp += (int)(dest - source);
		yy_current_buffer->yy_n_chars = yy_n_chars = yy_current_buffer->yy_buf_size;

		if(yy_cp < yy_current_buffer->yy_ch_buf + 2)
			YY_FATAL_ERROR("flex scanner push-back overflow");
	}

	*--yy_cp = (char)c;

	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
}

int yyFlexLexer::yyinput()
{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if(*yy_c_buf_p == YY_END_OF_BUFFER_CHAR)
	{
		/* yy_c_buf_p now points to the character we want to return.
																		 * If this occurs *before* the EOB characters, then it's a
																		 * valid NUL; if not, then we've hit the end of the buffer.
																		 */
		if(yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars])
		/* This was really a NUL. */
			*yy_c_buf_p = '\0';
		else
		{
			/* need more input */
			int offset = yy_c_buf_p - yytext_ptr;
			++yy_c_buf_p;

			switch(yy_get_next_buffer())
			{
			case EOB_ACT_LAST_MATCH:
				/* This happens because yy_g_n_b()
																																					 * sees that we've accumulated a
																																					 * token and flags that we need to
																																					 * try matching the token before
																																					 * proceeding.  But for input(),
																																					 * there's no matching to consider.
																																					 * So convert the EOB_ACT_LAST_MATCH
																																					 * to EOB_ACT_END_OF_FILE.
																																					 */

				/* Reset buffer status. */
				yyrestart(yyin);

				/* fall through */

			case EOB_ACT_END_OF_FILE:
				{
					if(yywrap())
						return EOF;

					if(!yy_did_buffer_switch_on_eof)
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p = yytext_ptr + offset;
				break;
			}
		}
	}

	c = *(unsigned char*)yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;

	return c;
}

void yyFlexLexer::yyrestart(istream* input_file)
{
	if(!yy_current_buffer)
		yy_current_buffer = yy_create_buffer(yyin, YY_BUF_SIZE);

	yy_init_buffer(yy_current_buffer, input_file);
	yy_load_buffer_state();
}

void yyFlexLexer::yy_switch_to_buffer(YY_BUFFER_STATE new_buffer)
{
	if(yy_current_buffer == new_buffer)
		return;

	if(yy_current_buffer)
	{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
	}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
}

void yyFlexLexer::yy_load_buffer_state()
{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
}

YY_BUFFER_STATE yyFlexLexer::yy_create_buffer(istream* file, int size)
{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE)yy_flex_alloc(sizeof(struct yy_buffer_state));
	if(!b)
		YY_FATAL_ERROR("out of dynamic memory in yy_create_buffer()");

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char*)yy_flex_alloc(b->yy_buf_size + 2);
	if(!b->yy_ch_buf)
		YY_FATAL_ERROR("out of dynamic memory in yy_create_buffer()");

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b, file);

	return b;
}

void yyFlexLexer::yy_delete_buffer(YY_BUFFER_STATE b)
{
	if(!b)
		return;

	if(b == yy_current_buffer)
		yy_current_buffer = (YY_BUFFER_STATE)0;

	if(b->yy_is_our_buffer)
		yy_flex_free((void*)b->yy_ch_buf);

	yy_flex_free((void*)b);
}

extern "C" int isatty YY_PROTO((int));
void yyFlexLexer::yy_init_buffer(YY_BUFFER_STATE b, istream* file)
{
	yy_flush_buffer(b);

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

	b->yy_is_interactive = 0;
}

void yyFlexLexer::yy_flush_buffer(YY_BUFFER_STATE b)
{
	if(!b)
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if(b == yy_current_buffer)
		yy_load_buffer_state();
}

#ifndef YY_NO_SCAN_BUFFER
#endif

#ifndef YY_NO_SCAN_STRING
#endif

#ifndef YY_NO_SCAN_BYTES
#endif

#ifndef YY_NO_PUSH_STATE
void yyFlexLexer::yy_push_state(int new_state)
{
	if(yy_start_stack_ptr >= yy_start_stack_depth)
	{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof(int);

		if(!yy_start_stack)
			yy_start_stack = (int*)yy_flex_alloc(new_size);
		else
			yy_start_stack = (int*)yy_flex_realloc((void*)yy_start_stack, new_size);

		if(!yy_start_stack)
			YY_FATAL_ERROR("out of memory expanding start-condition stack");
	}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
}

#endif

#ifndef YY_NO_POP_STATE
void yyFlexLexer::yy_pop_state()
{
	if(--yy_start_stack_ptr < 0)
		YY_FATAL_ERROR("start-condition stack underflow");

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
}

#endif

#ifndef YY_NO_TOP_STATE
int yyFlexLexer::yy_top_state()
{
	return yy_start_stack[yy_start_stack_ptr - 1];
}

#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

void yyFlexLexer::LexerError(yyconst char msg[])
{
	cerr << msg << '\n';
	exit(YY_EXIT_FAILURE);
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )

/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy(char* s1, yyconst char* s2, int n)
#else
static void yy_flex_strncpy(s1, s2, n)
char*s1;
yyconst char* s2;
int n;
#endif
{
	register int i;
	for(i = 0;i < n;++i)
		s1[i] = s2[i];
}

#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen(yyconst char* s)
#else
static int yy_flex_strlen(s)
yyconst char*s;
#endif
{
	register int n;
	for(n = 0;s[n];++n)
		;

	return n;
}

#endif

#ifdef YY_USE_PROTOS
static void* yy_flex_alloc(yy_size_t size)
#else
static void *yy_flex_alloc(size)
yy_size_t size;
#endif
{
	return (void*)malloc(size);
}

#ifdef YY_USE_PROTOS
static void* yy_flex_realloc(void *ptr, yy_size_t size)
#else
static void *yy_flex_realloc(ptr, size)
void* ptr;
yy_size_t size;
#endif
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void*)realloc((char*)ptr, size);
}

#ifdef YY_USE_PROTOS
static void yy_flex_free(void* ptr)
#else
static void yy_flex_free(ptr)
void*ptr;
#endif
{
	free(ptr);
}

#if YY_MAIN
int main()
{
	yylex();
	return 0;
}

#endif

