////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once

#include <strstream>
#include <iomanip>


#define MAX_TAG_NAME_SIZE 16
#define MAX_TAG_ATTR_SIZE 24

#define NOFRAME 1
#define FRAME 2
#define IMGSRC 3

class tagData
{
public:
	const char* name;
	const char* attr;
	int			rewrite_val;

	tagData(char* name, char* attr, int rewrite_val) : name(name), attr(attr), rewrite_val(rewrite_val)
	{
	}
};

class PsiphonHandler;

class CPsiphonContFilter //just quick sketch for now

{
	static const tagData	m_tags[];
	static const char* 		jsEvents[];

private:
	char					m_cur_tag_name[MAX_TAG_NAME_SIZE];
	char					m_cur_tag_attr[MAX_TAG_ATTR_SIZE];

	char* 					m_cur_content;
	int						m_n_cur_token;
	bool					m_bStripJS;
	bool					m_bStripObjects;
	bool					m_bStripImages;
	PsiphonHandler* 		m_pSh;

	//	char* m_pServerIP;
	//	char* m_pServerPort;

public:
							CPsiphonContFilter(PsiphonHandler* _pSh, bool bStripJS, bool bStripObjects, bool bStripImages = false);
							~CPsiphonContFilter();

public:
	int						ProcessContent(std::istrstream* sStream, char* baseurl);
	int						ProcessCSS(std::istrstream* sStream, char* baseurl);
	char*					DecodeAttrVal(char* content);
	void					DecodeHTMLEntity(char** val, std::strstream* stream);

protected:
	int						PutHTMLContent(char* baseurl);
	int						PutCSSContent(char* baseurl);
	int						IfRewrite();
	int						IsJS();

	char*					GetServerIP();
	char*					GetServerPort();
};
