////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once

class CPsiphonURL
{
private:
	const char* m_base;			/* URL base */
	const char* m_url;			/* original URL */

	char* 		m_authority;			
	int			m_port;			

	char* 		m_path;
	char* 		m_query;
	char* 		m_fragment;

	char* 		m_user;
	char* 		m_passwd;

public:
				CPsiphonURL(char* url, char* base); /*inits with original URL and base*/
				~CPsiphonURL(void);

	int			TransformURL(char*&);

protected:
	int			URLHasScheme(const char*); 
	//	int IsAllowedScheme(const char*);
	int			SchemeChar(const char*);
	char*		MergeURL();
	int			URLPathLength(const char* url);
};
