////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once

class PsiphonHandler;

class CLanguageData
{
	char* 	m_dir;
	char* 	m_language;
public:
			CLanguageData();
			~CLanguageData(void);
	char*	GetDir();
	char*	GetLanguage();
	void	SetDir(char* sDir);
	void	SetLanguage(char* sLanguage);
};

class CPsiphonUtils
{
	PsiphonHandler* m_pSh;

public:
					CPsiphonUtils(PsiphonHandler* _pSh);
					~CPsiphonUtils(void);

public:
	int				GetLanguagesData(CLanguageData lang[], int nLangSize);
	int				ReadLanguageFile(CLanguageData** lang);
	const char*		GetCookieData(const char* cookieName);
	int				GetHTML(const char* template_filename, char*& content);
	int				GetLanguageHTML(const char* template_filename, char*& content, const char* language_dir);
	const char*		GetLanguageDir(void);

	static bool		IsExternalIP(const char* pIP);
};


