////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once


class wxCertDlg : public wxPanel
{
	wxTextCtrl* m_Common;
	wxTextCtrl* m_Unit;
	wxTextCtrl* m_Organization;
	wxTextCtrl* m_Email;
	wxComboBox* m_Country;
	wxTextCtrl* m_State;
	wxCheckBox* m_RegenrateOnStartUp; 
	wxTextCtrl* m_Finger;
	wxButton* 	m_Generate;

	bool m_bCertificateChanged;

public:
	wxCertDlg();
	wxCertDlg(wxWindow* parent);
	~wxCertDlg();

	bool Create(wxWindow* parent);
	void CreateControls();

	bool IsCertificateChanged()
	{
		return m_bCertificateChanged;
	}

public:
	void LoadSettings();
	bool SaveSettings();

protected:
	void LoadCountry();
	void SelectCountry(wxString sCode);
	wxString GetCountryCode();

protected:
	void OnCertificateChanged(wxCommandEvent&);

	DECLARE_DYNAMIC_CLASS(wxCertDlg)
	DECLARE_EVENT_TABLE()
};

