////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once


class wxPsiphonDlg;

class wxLinkDlg : public wxPanel
{
	wxPsiphonDlg* 	m_pPsiphonDlg;

	wxTextCtrl* m_IP;
	wxTextCtrl* m_PORT;
	wxTextCtrl* m_LINK;
	wxTextCtrl* m_NAME;
	wxCheckBox* m_AutoUpdateIP;	
	wxCheckBox* m_AutoTestPORT;	
	wxComboBox*	m_GetIPServers;

	bool m_bLinkChanged;

public:
	wxLinkDlg();
	wxLinkDlg(wxPsiphonDlg* _pPsiphonDlg, wxWindow* parent);
	~wxLinkDlg();

	bool Create(wxWindow* parent);
	void CreateControls();
	bool IsLinkChanged()
	{
		return m_bLinkChanged;
	}

public:
	void LoadSettings();
	bool SaveSettings();
	void OnLinkChanged();

protected:
	void OnUpdateIP(wxCommandEvent&);
	void OnTestPort(wxCommandEvent&);
	void OnLinkChange(wxCommandEvent&);

	DECLARE_DYNAMIC_CLASS(wxLinkDlg)
	DECLARE_EVENT_TABLE()
};

