////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#include "stdwx.h"
#include "ListCtrlSort.h"
#include "strfunc.h"

BEGIN_EVENT_TABLE(wxListCtrlSort, wxListCtrl)
   EVT_LIST_COL_CLICK(wxID_ANY, wxListCtrlSort::OnColumnClick)
END_EVENT_TABLE()

void wxListCtrlSort::OnColumnClick(wxListEvent &event)
{
   if(event.GetColumn() == m_info.m_nColumn) 
   {
      m_info.m_bSortAscending = !m_info.m_bSortAscending;
   }
   else 
   {
       m_info.m_bSortAscending = true;
   }
  
   m_info.m_nColumn = event.GetColumn(); 

   m_info.m_pListCtrl = this; 
   SortItems(CompareFunction, (long) &m_info);
} 

int wxCALLBACK wxListCtrlSort::CompareFunction(long nItem1, long nItem2, long nSortInfo)
{
	CSortInfo* pSortInfo = (CSortInfo*) nSortInfo;

	wxListCtrlSort* pListCtrl = pSortInfo->m_pListCtrl; 
	int nColumn = pSortInfo->m_nColumn; 
	bool nSortAscending = pSortInfo->m_bSortAscending; 

	long nIndex1 = pListCtrl->FindItem(-1, nItem1); 
	long nIndex2 = pListCtrl->FindItem(-1, nItem2); 
	
	wxString sText1 = pListCtrl->GetText(nIndex1, nColumn); 
	wxString sText2 = pListCtrl->GetText(nIndex2, nColumn); 

	if(pSortInfo->arSortAsNumber[nColumn] == true)
	{
		double nValue1 = atof(sText1);
		double nValue2 = atof(sText2);

		if(nSortAscending)
			return nValue1 - nValue2;
		else
			return nValue2 - nValue1;
	}
	else
	{
		if(nSortAscending)
			return stricmp(sText1.c_str(), sText2.c_str());
		else
			return stricmp(sText2.c_str(), sText1.c_str());
	}
}

wxString wxListCtrlSort::GetText(long nIndex, int nColumn)
{
	wxListItem Item; 

	Item.SetId(nIndex); 
	Item.SetColumn(nColumn); 
	Item.SetMask(wxLIST_MASK_TEXT); 

	GetItem(Item); 

	return Item.GetText(); 
} 
