////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once

class wxListCtrlSort;
class CSortInfo
{
public:
	int m_nColumn; 
	bool m_bSortAscending;
	wxListCtrlSort* m_pListCtrl;
	bool arSortAsNumber[64];

public:
	CSortInfo()
	{
		m_nColumn = -1;		
		m_bSortAscending = false;
		m_pListCtrl = NULL;

		for(int i = 0; i < 64; i++)
			arSortAsNumber[i] = false;
	}
};

class wxListCtrlSort : public wxListCtrl
{
	CSortInfo m_info;

public:
	wxListCtrlSort(wxWindow *parent,
               wxWindowID id = wxID_ANY,
               const wxPoint& pos = wxDefaultPosition,
               const wxSize& size = wxDefaultSize,
               long style = wxLC_ICON,
               const wxValidator& validator = wxDefaultValidator,
               const wxString& name = wxListCtrlNameStr)
	:wxListCtrl(parent, id, pos, size, style, validator, name)
    {
    }

public:
	wxString GetText(long nIndex, int nColumn);

	static int wxCALLBACK CompareFunction(long item1, long item2, long sortinfo);

    long InsertColumn( long col, const wxString& heading,
                       int format = wxLIST_FORMAT_LEFT, int width = -1, bool bSortAsNumber = false)
	{
		m_info.arSortAsNumber[col] = bSortAsNumber;
		return wxListCtrl::InsertColumn(col, heading, format, width);
	}


protected:
	void OnColumnClick(wxListEvent &event);
	DECLARE_EVENT_TABLE() 
};
