////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once


#include "ListCtrlSort.h"
class wxPsiphonDlg;

class wxLogDlg : public wxPanel
{
	enum
	{
		CLMN_MESSAGE = 0,
		CLMN_USER_ID,
		CLMN_TIME,
	};

	wxListCtrlSort* m_loglist;
	wxComboBox* 	m_cmbLevel;
	wxPsiphonDlg* 	m_pPsiphonDlg;

public:
	wxLogDlg();
	wxLogDlg(wxPsiphonDlg* _pPsiphonDlg, wxWindow* parent);

	bool Create(wxWindow* parent);
	void CreateControls();

public:
	void Log(const wxString& msg, int nUserID = -1);

protected:
	void Init();
	void Cleanup();
	void LogItToFile(const wxString& msg);

protected:
	void OnInitDialog(wxInitDialogEvent&);
	void OnCleanup(wxCommandEvent&);
	void OnLevelChanged(wxCommandEvent&);
	void OnListItemActivated(wxListEvent&);

	DECLARE_DYNAMIC_CLASS(wxLogDlg)
	DECLARE_EVENT_TABLE()
};
