////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#include "stdwx.h"
#include "PsiphonApp.h"
#include "PsiphonDlg.h"
#include "SetupInfo.h"
#include "SetupDlg.h"
#include "GetIP.h"
#include "update.h"
#include "cert.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

wxPsiphonApp::wxPsiphonApp()
{
}

wxPsiphonApp::~wxPsiphonApp()
{
}

void wxPsiphonApp::ChooseLanguage()
{
	if(wxMessageBox(_("would you like to see it in Russian?"), _("choose language"), wxYES_NO | wxICON_QUESTION) != wxYES)
		return;

	m_locale.AddCatalogLookupPathPrefix(wxT(".")); 
	m_locale.AddCatalogLookupPathPrefix(wxT("..")); 
	m_locale.Init(wxLANGUAGE_RUSSIAN);
	m_locale.AddCatalog(_T("russian"));
}

void wxPsiphonApp::ShowSplash(wxPsiphonDlg* parent)
{
	wxBitmap bitmap;
	bitmap.LoadFile(_T("splash.bmp"), wxBITMAP_TYPE_BMP);
	wxSplashScreen* splash = new wxSplashScreen(bitmap, wxSPLASH_CENTRE_ON_PARENT | wxSPLASH_TIMEOUT, 2000, parent, -1, wxDefaultPosition, wxDefaultSize, wxSIMPLE_BORDER | wxSTAY_ON_TOP); 	  
	splash->Show(TRUE); 		
	wxYield();
}

bool wxPsiphonApp::OnInit()
{
	SetVendorName(_T("'CitizenLab'"));
	SetAppName(_T("'psiphon'"));

	g_info.Load();

//	ChooseLanguage();
	UpdateDatabase();

	wxPsiphonDlg* mainWindow = new wxPsiphonDlg(NULL);

#ifndef _DEBUG
	ShowSplash(mainWindow);
#endif

	if(!InstallCertificate()) //AFF run after mainWindow is created
	{
		wxMessageBox(_("Failed to install SSL certificate."), _("psiphon"));
		return false;
	}

	mainWindow->Show(true);

	return true;
}

int wxPsiphonApp::OnExit()
{
	return wxApp::OnExit();
}

void wxPsiphonApp::Restart()
{
	wxString sCommand = _T("psiphon.exe");
	wxExecute(sCommand, wxEXEC_ASYNC, NULL);
	wxExit();
}

IMPLEMENT_APP(wxPsiphonApp)
