////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "Server.h"

class CConfigData;
class wxUserDlg;
class wxLogDlg;
class wxHyperlinkCtrl;
class CPsiphonTaskBarIcon;

class wxPsiphonDlg : public wxDialog
{
	wxLogDlg* m_pLogDlg;
	wxUserDlg* m_pUserDlg;

	CPsiphonTaskBarIcon* m_taskBarIcon;
	wxHyperlinkCtrl* 	m_Hyperlink;

	wxButton* m_btnStart;
	wxButton* m_btnStop;

	wxIcon	m_icoON;
	wxIcon	m_icoOFF;

	CAppWebServer		m_server;
	wxString m_sCurrentStatus;

public:
	wxPsiphonDlg();
	wxPsiphonDlg(wxWindow* parent);
	~wxPsiphonDlg();

	bool	Create(wxWindow* parent);
	void	CreateControls();

	bool	IsServerRunning();
	void	StartServer();
	bool	StopServer(bool bSilent = false);
	void	RestartServer();
	void	Setup();
	void	Exit();

	void	Restore();
	void	Hide();

protected:
	void	SetLink(wxString sLink);
	void	UpdateLink();

	void	RunStartUps();
	bool	CheckForUpdatesOnStartup();
	bool	UpdateName();
	bool	AutoUpdateIP();
	bool	AutoTestPort();
	void	AutoInstallCertificate();

	void	PsiphonIsOFF();
	void	PsiphonIsON();
	wxString SetTitleStatus(wxString sStatus);
	void	SetIconON(bool bON);
	bool	FindAvailablePort();

protected:
	void	OnInitDialog(wxInitDialogEvent&);
	void	OnRunStartUps(wxCommandEvent&);

	void	OnStartServer(wxCommandEvent& e);
	void	OnStopServer(wxCommandEvent& e);
	void	OnSetup(wxCommandEvent& e);
	void	OnExit(wxCommandEvent& e);

	void	OnEventLog(wxCommandEvent& evt);
	void	OnServerCrashed(wxCommandEvent& evt);
	void	OnCloseWindow(wxCloseEvent&);

	DECLARE_DYNAMIC_CLASS(wxPsiphonDlg)
	DECLARE_EVENT_TABLE()
};

DECLARE_EVENT_TYPE(wxEVT_RUN_START_UPS, -1)

