////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#include "stdwx.h"
#include "PsiphonLog.h"
#include "convert.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

DEFINE_EVENT_TYPE(wxEVT_LOG)
DEFINE_EVENT_TYPE(wxEVT_SERVER_CRASHED)

void wxPsiphonLog::logEvent(char*, int, int level, char*, char*msg)
{
	if(level > m_loglevel)
		return;

	CConverter wMsg(msg);
	postLogMessage(wMsg);
}

void wxPsiphonLog::postLogMessage(const char* msg)
{
	wxCommandEvent event(wxEVT_LOG);
	event.SetString(msg);
	wxPostEvent(wxTheApp->GetTopWindow(), event);
}

void wxPsiphonLog::postServerCrashedMessage()
{
	wxCommandEvent event(wxEVT_SERVER_CRASHED);
	wxPostEvent(wxTheApp->GetTopWindow(), event);
}

