////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#include "stdwx.h"
#include "resources.h"
#include "PsiphonNameDlg.h"
#include "User.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC_CLASS(wxPsiphonNameDlg, wxDialog)

enum
{
	IDC_NAME = 10001,
};

bool IsAlphaNumeric(wxString sName);

wxPsiphonNameDlg::wxPsiphonNameDlg()
{
}

wxPsiphonNameDlg::wxPsiphonNameDlg(wxWindow* parent)
{
	Create(parent);
}

bool wxPsiphonNameDlg::Create(wxWindow* parent)
{
	SetExtraStyle(GetExtraStyle() | wxWS_EX_BLOCK_EVENTS);
	wxDialog::Create(parent, IDD_PSIPHON_NAME, _("psiphon name"), wxDefaultPosition, wxSize(400, 300), wxCAPTION | wxSYSTEM_MENU | wxCLOSE_BOX | wxDIALOG_MODAL);

	CreateControls();

	if(GetSizer())
	{
		GetSizer()->SetSizeHints(this);
	}

	Centre();

	return true;
}

void wxPsiphonNameDlg::CreateControls()
{
	wxPsiphonNameDlg* itemDialog1 = this;

	wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
	itemDialog1->SetSizer(itemBoxSizer2);

	wxBoxSizer* itemBoxSizer3 = new wxBoxSizer(wxVERTICAL);
	itemBoxSizer2->Add(itemBoxSizer3, 0, wxALIGN_CENTER_HORIZONTAL | wxALL, 5);

	//server name
	wxBoxSizer* itemBoxSizerNAME = new wxBoxSizer(wxVERTICAL);
	itemBoxSizer2->Add(itemBoxSizerNAME, 0, wxALIGN_LEFT | wxALL, 5);

	wxStaticText* itemStaticText5 = new wxStaticText(this, wxID_STATIC, _("Please name your psiphon (a-Z, 0-9)."), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizerNAME->Add(itemStaticText5, 0, wxALIGN_LEFT | wxALL | wxADJUST_MINSIZE, 5);
	//
	wxBoxSizer* itemBoxSizerNAMEEnter = new wxBoxSizer(wxHORIZONTAL);
	itemBoxSizerNAME->Add(itemBoxSizerNAMEEnter, 0, wxALIGN_LEFT | wxALL, 5);

	wxStaticText* itemStaticText6 = new wxStaticText(this, wxID_STATIC, _("Name:"), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizerNAMEEnter->Add(itemStaticText6, 0, wxALIGN_CENTER_VERTICAL | wxALL | wxADJUST_MINSIZE, 5);

	m_txtName = new wxTextCtrl(this, IDC_NAME, _T(""), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizerNAMEEnter->Add(m_txtName, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
	//

	wxBoxSizer* itemBoxSizer16 = new wxBoxSizer(wxHORIZONTAL);
	itemBoxSizer2->Add(itemBoxSizer16, 0, wxALIGN_CENTER_HORIZONTAL | wxALL, 5);

	wxButton* itemButton17 = new wxButton(itemDialog1, wxID_OK, _("&OK"), wxDefaultPosition, wxDefaultSize, 0);
	itemButton17->SetDefault();
	itemBoxSizer16->Add(itemButton17, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);

	wxButton* itemButton18 = new wxButton(itemDialog1, wxID_CANCEL, _("&Exit"), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizer16->Add(itemButton18, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
}

wxString wxPsiphonNameDlg::GetName()
{
	return m_sPsiphonName;
}

BEGIN_EVENT_TABLE(wxPsiphonNameDlg, wxDialog)
	EVT_INIT_DIALOG(wxPsiphonNameDlg::OnInitDialog) 
	EVT_BUTTON(wxID_OK, wxPsiphonNameDlg::OnOK)
END_EVENT_TABLE()

void wxPsiphonNameDlg::OnInitDialog(wxInitDialogEvent &)
{
}

void wxPsiphonNameDlg::OnOK(wxCommandEvent&)
{
	wxString sName = m_txtName->GetValue();

	if(sName.IsEmpty())
	{
		wxMessageBox(_("psiphon name cannot be empty."), _("Setup"));
		return;
	}

	if(!IsAlphaNumeric(sName))
	{
		wxMessageBox(_("psiphon name is invalid."), _("Setup"));
		return;
	}

	m_sPsiphonName = sName;
	EndModal(wxID_OK);
}
