////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once

class MprLogListener;

typedef void (*CRASH_ROUTINE)();

class CConfigData
{
public:
	int	m_nLogLevel;
	int	m_nPort;
	
	MprLogListener* m_logFunc;
	CRASH_ROUTINE	m_crashFunc;

public:
	CConfigData()
	{
		m_logFunc = NULL;
	}
	~CConfigData()
	{
		delete m_logFunc;
	}
};

class CAppWebServer;
class CServerThread : public wxThread
{
	CAppWebServer* 	m_pServer;

public:
	CServerThread(CAppWebServer* pServer);
	virtual void*	Entry();
};

class CAppWebServer
{
public:
	CConfigData	m_config;

	Mpr* m_pMPR;
	MaHttp* m_pHTTP;
	MaServer* m_pServer;
	
	bool	m_bWantOut;
	bool	m_bRunning;

public:
	CAppWebServer();
	~CAppWebServer();

	bool	IsServerRunning();
	void	GetIP(char** pIP);
	int		GetPORT();

	bool	Start();
	bool	Stop();

	bool	init();
	void	reset();
};
