////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once



class wxLinkDlg;
class wxPrefDlg;
class wxPsiphonDlg;
class wxCertDlg;

class wxSetupDlg : public wxDialog
{
	wxPsiphonDlg* m_pPsiphonDlg;

	wxLinkDlg* m_pSettingsDlg;
	wxPrefDlg* m_pPrefDlg;
	wxCertDlg* m_pCertDlg;

	bool m_bCertificateChanged;
	bool m_bLinkChanged;

public:
	wxSetupDlg();
	wxSetupDlg(wxPsiphonDlg* _pPsiphonDlg);

	bool Create(wxWindow* parent);
	void CreateControls();
	bool IsCertificateChanged()
	{
		return m_bCertificateChanged;
	}
	bool IsLinkChanged()
	{
		return m_bLinkChanged;
	}

protected:
	void OnInitDialog(wxInitDialogEvent& event);
	void OnOK(wxCommandEvent& event);

	DECLARE_DYNAMIC_CLASS(wxSetupDlg)
	DECLARE_EVENT_TABLE()
};

