////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once

class wxDownloadEvent;
class wxDownloadFile;

class wxUpdateDlg : public wxDialog
{
	wxString m_sLatestVersion;
	wxString m_sCurrentVersion;
	wxString m_sFile;
	wxString m_sPath;

	wxGauge* m_Progress;
	wxButton* m_btnGetUpdate;
	
	wxDownloadFile* m_pDownloadFile;
	bool m_bDownloading;

	wxStaticText* m_stMessage;

public:
	wxUpdateDlg();
	~wxUpdateDlg();
	wxUpdateDlg(const wxString& _sLatestVersion, const wxString& _sCurrentVersion, wxWindow* parent);

	bool Create(wxWindow* parent);
	void CreateControls();

public:
	static bool CheckForUpdates(wxWindow* parent, bool bShowNoUpdates);
	static wxString GetUpdateFileName(const wxString& sVersion);
	static wxString GetUpdatePath(const wxString& sVersion);

protected:
	void OnGetUpdate(wxCommandEvent&);
	void OnCancel(wxCommandEvent&);
	void OnDownloadEvent(wxDownloadEvent&);

	DECLARE_DYNAMIC_CLASS(wxUpdateDlg)
	DECLARE_EVENT_TABLE()
};
