////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#include "stdwx.h"
#include "resources.h"
#include "UserDetailsDlg.h"
#include "User.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC_CLASS(wxUserDetailsDlg, wxDialog)

enum
{
	IDC_USERNAME  = 10001,
	IDC_PASSWORD,
	IDC_CONFIRM_PASSWORD,
	IDC_EMAIL,
	IDC_FULLNAME,
};

wxUserDetailsDlg::wxUserDetailsDlg()
{
}

wxUserDetailsDlg::wxUserDetailsDlg(CDBUser* _pUser, wxWindow* parent)
{
	m_pUser = _pUser;
	Create(parent);
}

bool wxUserDetailsDlg::Create(wxWindow* parent)
{
	SetExtraStyle(GetExtraStyle() | wxWS_EX_BLOCK_EVENTS);
	wxDialog::Create(parent, IDD_USER_DETAILS, _("User Details"), wxDefaultPosition, wxSize(400, 300), wxCAPTION|wxSYSTEM_MENU|wxCLOSE_BOX|wxDIALOG_MODAL);

	CreateControls();

	if(GetSizer())
	{
		GetSizer()->SetSizeHints(this);
	}

	Centre();

	return true;
}

void wxUserDetailsDlg::CreateControls()
{
	wxUserDetailsDlg* itemDialog1 = this;

	wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
	itemDialog1->SetSizer(itemBoxSizer2);

	wxBoxSizer* itemBoxSizer3 = new wxBoxSizer(wxVERTICAL);
	itemBoxSizer2->Add(itemBoxSizer3, 0, wxALIGN_CENTER_HORIZONTAL | wxALL, 5);

	wxBoxSizer* itemBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
	itemBoxSizer3->Add(itemBoxSizer4, 0, wxALIGN_RIGHT | wxALL, 5);

	wxStaticText* itemStaticText5 = new wxStaticText(itemDialog1, wxID_STATIC, _("Username:"), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizer4->Add(itemStaticText5, 0, wxALIGN_CENTER_VERTICAL | wxALL | wxADJUST_MINSIZE, 5);

	m_Username = new wxTextCtrl(itemDialog1, IDC_USERNAME, _T(""), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizer4->Add(m_Username, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);

	wxBoxSizer* itemBoxSizer7 = new wxBoxSizer(wxHORIZONTAL);
	itemBoxSizer3->Add(itemBoxSizer7, 0, wxALIGN_RIGHT | wxALL, 5);

	wxStaticText* itemStaticText8 = new wxStaticText(itemDialog1, wxID_STATIC, _("New password:"), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizer7->Add(itemStaticText8, 0, wxALIGN_CENTER_VERTICAL | wxALL | wxADJUST_MINSIZE, 5);

	m_Password = new wxTextCtrl(itemDialog1, IDC_PASSWORD, _T(""), wxDefaultPosition, wxDefaultSize, wxTE_PASSWORD);
	itemBoxSizer7->Add(m_Password, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);

	wxBoxSizer* itemBoxSizer8 = new wxBoxSizer(wxHORIZONTAL);
	itemBoxSizer3->Add(itemBoxSizer8, 0, wxALIGN_RIGHT | wxALL, 5);

	wxStaticText* itemStaticText9 = new wxStaticText(itemDialog1, wxID_STATIC, _("Confirm password:"), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizer8->Add(itemStaticText9, 0, wxALIGN_CENTER_VERTICAL | wxALL | wxADJUST_MINSIZE, 5);

	m_ConfirmPassword = new wxTextCtrl(itemDialog1, IDC_CONFIRM_PASSWORD, _T(""), wxDefaultPosition, wxDefaultSize, wxTE_PASSWORD);
	itemBoxSizer8->Add(m_ConfirmPassword, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
//
	wxBoxSizer* itemBoxSizer13 = new wxBoxSizer(wxHORIZONTAL);
	itemBoxSizer3->Add(itemBoxSizer13, 0, wxALIGN_RIGHT | wxALL, 5);

	wxStaticText* itemStaticText14 = new wxStaticText(itemDialog1, wxID_STATIC, _("Full name:"), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizer13->Add(itemStaticText14, 0, wxALIGN_CENTER_VERTICAL | wxALL | wxADJUST_MINSIZE, 5);

	m_Fullname = new wxTextCtrl(itemDialog1, IDC_FULLNAME, _T(""), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizer13->Add(m_Fullname, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
//
	wxBoxSizer* itemBoxSizer10 = new wxBoxSizer(wxHORIZONTAL);
	itemBoxSizer3->Add(itemBoxSizer10, 0, wxALIGN_RIGHT | wxALL, 5);

	wxStaticText* itemStaticText11 = new wxStaticText(itemDialog1, wxID_STATIC, _("E-mail:"), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizer10->Add(itemStaticText11, 0, wxALIGN_CENTER_VERTICAL | wxALL | wxADJUST_MINSIZE, 5);

	m_Email = new wxTextCtrl(itemDialog1, IDC_EMAIL, _T(""), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizer10->Add(m_Email, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
//
	wxBoxSizer* itemBoxSizer16 = new wxBoxSizer(wxHORIZONTAL);
	itemBoxSizer3->Add(itemBoxSizer16, 0, wxALIGN_CENTER_HORIZONTAL | wxALL, 5);

	wxButton* itemButton17 = new wxButton(itemDialog1, wxID_OK, _("&OK"), wxDefaultPosition, wxDefaultSize, 0);
	itemButton17->SetDefault();
	itemBoxSizer16->Add(itemButton17, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);

	wxButton* itemButton18 = new wxButton(itemDialog1, wxID_CANCEL, _("&Cancel"), wxDefaultPosition, wxDefaultSize, 0);
	itemBoxSizer16->Add(itemButton18, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
}

BEGIN_EVENT_TABLE(wxUserDetailsDlg, wxDialog)
	EVT_INIT_DIALOG(wxUserDetailsDlg::OnInitDialog) 
	EVT_BUTTON(wxID_OK, wxUserDetailsDlg::OnOK)
END_EVENT_TABLE()

void wxUserDetailsDlg::OnInitDialog(wxInitDialogEvent &)
{
	if(m_pUser->GetUsername() != NULL)
		m_Username->SetEditable(false);

	m_Username->SetValue(m_pUser->GetUsername());

	m_Password->SetValue(_T("")); 
	m_ConfirmPassword->SetValue(_T(""));

	m_Email->SetValue(m_pUser->GetEmail());
	m_Fullname->SetValue(m_pUser->GetFullName());
}

void wxUserDetailsDlg::OnOK(wxCommandEvent&)
{
	wxString sUsername = m_Username->GetValue();
	if(sUsername == _T(""))
	{
		wxMessageBox(_("Username cannot be empty."), _("User Details"));
		m_Username->SetFocus();
		return;
	}

	if(sUsername.Length() > 100)
	{
		wxMessageBox(_("Username cannot be longer than 100 characters."), _("User Details"));
		m_Username->SetFocus();
		return;
	}

	if(m_pUser->GetUsername() == NULL  	//we are adding a new user
	   && CDBUser::FindUsername(sUsername) >= 0)
	{
		wxMessageBox(_("Username is not available."), _("User Details"));
		m_Username->SetFocus();
		return;
	}

	wxString sNewPassword = m_Password->GetValue();

	if(m_pUser->GetUsername() == NULL && sNewPassword == _T(""))
	{
		wxMessageBox(_("Password cannot be empty."), _("User Details"));	
		m_Password->SetFocus();
		return;
	}

	if(sNewPassword.Length() > 64)
	{
		wxMessageBox(_("Password cannot be longer than 64 characters."), _("User Details"));
		m_Password->SetFocus();
		return;
	}	

	wxString sConfirmPassword = m_ConfirmPassword->GetValue();
	if(sNewPassword != sConfirmPassword)
	{
		wxMessageBox(_("Failed to confirm new password."), _("User Details"));	
		m_ConfirmPassword->SetFocus();
		return;
	}

	wxString sEmail = m_Email->GetValue();
	if(sEmail.Length() > 100)
	{
		wxMessageBox(_("Email cannot be longer than 100 characters."), _("User Details"));
		m_Email->SetFocus();
		return;
	}

	wxString sFullName = m_Fullname->GetValue();
	if(sFullName.Length() > 100)
	{
		wxMessageBox(_("Fullname cannot be longer than 100 characters."), _("User Details"));
		m_Fullname->SetFocus();
		return;
	}

	//its all good
	m_pUser->SetUsername(sUsername);

	if(sNewPassword != _T(""))
	{
		char pKey[64];
		CDBUser::EncryptPassword(pKey, 64, sUsername, sNewPassword);
		m_pUser->SetPassword(pKey);
	}

	m_pUser->SetEmail(sEmail);
	m_pUser->SetFullName(sFullName);

	EndModal(wxID_OK);
}
