////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "User.h"
#include "logDetails.h"
#include "ListCtrlSort.h"

class wxUserDlg : public wxPanel
{
	enum
	{
		CLMN_USER_ID	= 0,
		CLMN_USER_NAME,
		CLMN_FULL_NAME,
		CLMN_E_MAIL,
		CLMN_LAST_ACCESS,
		CLMN_WRITTEN,
		CLMN_WRITE_SPEED,
		CLMN_READ_SPEAD,
	};

	wxListCtrlSort* m_pUserList;
	wxButton* m_btnAdd;
	wxButton* m_btnEdit;
	wxButton* m_btnRemove;

public:
	wxUserDlg();
	wxUserDlg(wxWindow* parent);
	~wxUserDlg();

	bool Create(wxWindow* parent);
	void CreateControls();

	bool Log(CPsiphonMessage* pLogDeatils);

protected:
	void AddUserToList(CDBUser* pUser);
	void Edit();
	void UpdateListItemStatistic(int nIndex);
	void UpdateListItemInfo(int nIndex);

protected:
	void OnInitDialog(wxInitDialogEvent&);
	void OnAdd(wxCommandEvent&);
	void OnEdit(wxCommandEvent&);
	void OnListItemActivated(wxListEvent&);
	void OnRemove(wxCommandEvent&);

	DECLARE_DYNAMIC_CLASS(wxUserDlg)
	DECLARE_EVENT_TABLE()
};
