////////////////////////////////////////////////////////////////////////////////
//	Copyright (c) CitizenLab, 2006. All Rights Reserved.
//	The latest version of this code is available at http://psiphon.civisec.org/
//
//	This software is open source; you can redistribute it and/or modify it 
//	under the terms of the GNU General Public License as published by the 
//	Free Software Foundation; either version 2 of the License, or (at your 
//	option) any later version.
//
//	This program is distributed WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details at:
//	http://psiphon.civisec.org/
//	
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.
////////////////////////////////////////////////////////////////////////////////

#include "stdwx.h"
#include "update.h"
#include "CppSQLite3.h"
#include "strfunc.h"

void DropTable(CppSQLite3DB& db, char* sTableName)
{
	try
	{
		CppSQLite3Statement stmt = db.compileStatement(_T("drop table ?"));
		stmt.bind(1, sTableName);	
		stmt.execDML();
	}
	catch(CppSQLite3Exception& )
	{
	}
}

void DropIndex(CppSQLite3DB& db, char* sIndexName)
{
	try
	{
		CppSQLite3Statement stmt = db.compileStatement(_T("drop index ?"));
		stmt.bind(1, sIndexName);	
		stmt.execDML();
	}
	catch(CppSQLite3Exception& )
	{
	}
}

void UpdateDatabase()
{
	try
	{
		wxString sFileName = _T("database.db");

		wxFile file;
		bool bRes = file.Exists(sFileName);
		if(bRes == false)
			return;

		CppSQLite3DB db;
		db.Open(_T("database.db"));

		DropTable(db, _T("bookmarks"));
		DropTable(db, _T("session_access"));
		DropTable(db, _T("session_cookies"));
		DropTable(db, _T("sessions"));

		DropIndex(db, _T("idx_user"));
		DropIndex(db, _T("idx_pwd"));

		db.Close();

		bRes = ::wxRenameFile(_T("database.db"), _T("users.db"));
	}
	catch(CppSQLite3Exception& )
	{
	}
}
